Loading...
Searching...
No Matches
BALL Namespace Reference

## Namespaces

namespace | Constants
namespace | Exception
namespace | RTTI
namespace | GRAPH
namespace | __private
namespace | VIEW
namespace | PDB
namespace | Maths
namespace | MolmecSupport
namespace | QSAR
namespace | Peptides
namespace | SimpleDownloaderHelper
namespace | SysInfo

## Classes

class | GlobalInitializer
class | LogStreamBuf
class | LogStreamNotifier
class | LogStream
class | VersionInfo
class | AutoDeletable
class | UnaryFunctor
class | BinaryFunctor
class | BaseIterator
class | ConstBidirectionalIterator
class | BidirectionalIterator
| Mutable bidirectional iterator. More...
class | Client
class | Comparator
class | Composite
class | Embeddable
class | EnumeratorIndex
class | Enumerator
class | Factory
class | ConstForwardIterator
class | ForwardIterator
class | MolecularInformation
class | MoleculeObjectCreator
class | Object
class | ObjectCreator
class | PersistenceManager
class | PersistentObject
class | UnaryPredicate
class | BinaryPredicate
class | PreferencesObject
class | Processor
class | UnaryProcessor
class | ConstUnaryProcessor
class | BinaryProcessor
class | ConstBinaryProcessor
class | NamedProperty
class | PropertyManager
class | ConstRandomAccessIterator
class | RandomAccessIterator
class | Selectable
class | TextPersistenceManager
class | PreciseTime
class | TimeStamp
class | Visitor
class | XDRPersistenceManager
class | Bit
class | BitVector
class | TContour
class | TContourLine
class | TContourSurface
class | MolecularGraph
class | TreeWidthImplementation
class | TreeWidth
class | HashGrid3
| Three-dimensional Hash Grid Class. More...
class | HashGridBox3
class | HashMap
| HashMap class based on the STL map (containing serveral convenience functions). More...
class | HashSet
class | List
class | Options
class | Quadruple
class | TRegularData1D
class | TRegularData2D
class | TRegularData3D
class | RegularExpression
class | String
class | Substring
class | StringHashMap
class | Triple
class | Conformation
class | ConformationSet
class | Constraint
class | ReferenceArea
class | PharmacophoreConstraint
class | DockingAlgorithm
class | DockResult
class | FlexDefinition
class | FlexibleMolecule
class | GridAnalysis
class | PoseClustering
| Computation of clusters of docking poses. More...
class | Receptor
class | Result
class | SideChainOptimizer
class | StaticLigandFragment
class | StructurePreparer
class | DockProblem
class | EvolutionaryDocking
class | GenericGene
class | DoubleGene
class | QuaternionGene
class | GeneticAlgorithm
class | GeneticIndividual
class | GenericParameter
class | DoubleParameter
class | QuaternionParameter
class | RotateBond
class | RotateBonds
class | GeometricFit
class | IMGDock
class | ComposedEnergyProcessor
class | EnergyProcessor
class | AmiraMeshFile
class | AntechamberFile
class | Bruker1DFile
class | Bruker2DFile
class | CCP4File
class | CIFFile
class | CommandlineParser
class | DCDFile
class | DockResultFile
class | DSN6File
class | GAMESSDatFile
class | GAMESSLogFile
class | GenericMolFile
class | HINFile
class | HMOFile
class | INIFile
class | JCAMPFile
class | KCFFile
class | LineBasedFile
class | MOL2File
class | MOLFile
class | MolFileFactory
class | MOPACInputFile
class | MOPACOutputFile
class | NMRStarFile
| This class provides methods for reading and assigning chemical shifts. More...
class | Parameters
class | ParameterSection
class | ParamFile
class | PDBFile
class | PDBInfo
class | PDBRecords
class | PubChemDownloader
| Downloads PubChem entries. More...
class | ResourceEntry
class | ResourceFile
class | SCWRLRotamerFile
| Reads Dunbrack/SCWRL rotamer library files. More...
class | SDFile
class | TrajectoryFile
class | TrajectoryFileFactory
class | TRRFile
class | XYZFile
class | Atom
class | AtomContainer
class | AtomContainerIteratorTraits
class | AtomIteratorTraits
class | Bond
class | Chain
class | ChainIteratorTraits
class | Expression
class | ExpressionParser
class | ExpressionPredicate
class | ExpressionTree
class | Fragment
class | FragmentIteratorTraits
class | CompositeIteratorTraits
class | MolecularInteractions
class | Molecule
class | MoleculeIteratorTraits
class | NucleicAcid
class | NucleicAcidIteratorTraits
class | Nucleotide
class | NucleotideIteratorTraits
class | PDBAtom
class | PDBAtomIteratorTraits
class | KernelPredicate
| Kernel predicate class. More...
class | KernelPredicate< Atom >
class | KernelPredicate< Molecule >
class | KernelPredicate< Protein >
class | KernelPredicate< Fragment >
class | KernelPredicate< Residue >
class | KernelPredicate< Chain >
class | Protein
class | ProteinIteratorTraits
class | Element
class | PTE_
class | Residue
class | ResidueIteratorTraits
class | SecondaryStructure
class | SecondaryStructureIteratorTraits
class | Selector
class | TruePredicate
class | FalsePredicate
class | SelectedPredicate
class | AtomNamePredicate
class | AtomTypePredicate
class | ElementPredicate
class | ResiduePredicate
class | ResidueIDPredicate
class | ProteinPredicate
class | ChainPredicate
class | SecondaryStructurePredicate
class | SolventPredicate
class | MoleculePredicate
class | BackBonePredicate
class | NucleicAcidPredicate
class | NucleotidePredicate
class | InRingPredicate
class | NumberOfBondsPredicate
class | SingleBondsPredicate
class | DoubleBondsPredicate
class | TripleBondsPredicate
class | AromaticBondsPredicate
class | ConnectedToPredicate
class | SpHybridizedPredicate
class | Sp2HybridizedPredicate
class | Sp3HybridizedPredicate
class | ChargePredicate
class | AxialPredicate
class | Conformation4C1Predicate
class | RingFinder
class | SMARTSPredicate
class | System
class | TAngle
class | TBox3
class | TCircle3
class | CubicSpline1D
class | CubicSpline2D
class | TFFT1D
class | TFFT2D
class | TFFT3D
struct | DoubleTraits
struct | FloatTraits
struct | LongDoubleTraits
class | ConstantFunction
class | MutableConstant
class | Addition
class | Subtraction
class | Product
class | Division
class | Reciprocal
class | SquareFunction
class | CubicFunction
class | MutablePower
class | TLine3
class | TMatrix4x4
| Default Type. More...
class | NumericalIntegrator
class | ParsedFunction
class | PiecewiseFunction
class | PiecewisePolynomial
class | TPlane3
class | TQuaternion
class | RombergIntegrator
class | TSimpleBox3
class | TSphere3
class | TSurface
class | TVector2
class | TVector3
class | TVector4
class | AmberFF
class | AmberBend
class | AmberNonBonded
class | AmberStretch
class | AmberTorsion
class | GAFFCESParser
class | GAFFTypeProcessor
class | CharmmFF
class | CharmmBend
class | CharmmImproperTorsion
class | CharmmNonBonded
class | CharmmStretch
class | CharmmTorsion
class | AssignBaseProcessor
| Only used for deriving interface. More...
class | AssignTypeProcessor
class | AssignTypeNameProcessor
class | AtomVector
class | BendComponent
class | ChargeRuleProcessor
class | ForceField
class | ForceFieldComponent
class | Gradient
class | PeriodicBoundary
class | RadiusRuleProcessor
class | RuleEvaluator
class | RuleProcessor
class | SnapShot
class | SnapShotManager
class | StretchComponent
class | TypenameRuleProcessor
class | TypeRuleProcessor
class | CanonicalMD
class | MicroCanonicalMD
class | MolecularDynamics
class | ConjugateGradientMinimizer
class | EnergyMinimizer
class | LineSearch
class | ShiftedLVMMMinimizer
class | SteepestDescentMinimizer
class | StrangLBFGSMinimizer
class | MMFF94
class | MMFF94NonBonded
class | MMFF94OutOfPlaneBend
class | MMFF94ParametersBase
class | MMFF94AtomTypeEquivalences
struct | MMFF94AtomType
| Class to store the values of an atom type from MMFFPROP.PAR. More...
class | MMFF94AtomTypes
class | MMFF94StretchParameters
class | MMFF94BendParameters
class | MMFF94StretchBendParameters
class | MMFF94TorsionParameters
class | MMFF94PlaneParameters
class | MMFF94VDWParameters
class | MMFF94ESParameters
class | MMFF94AtomTyper
class | MMFF94ChargeProcessor
class | MMFF94StretchBend
class | MMFF94Torsion
class | AtomTypes
class | CharmmEEF1
class | CosineTorsion
class | ForceFieldParameters
class | LennardJones
class | Potential1210
class | QuadraticAngleBend
class | QuadraticBondStretch
class | QuadraticImproperTorsion
class | ResidueTorsions
class | Templates
class | AnisotropyShiftProcessor
class | ClearShiftProcessor
class | CreateSpectrumProcessor
class | EFShiftProcessor
class | EmpiricalHSShiftProcessor
class | Experiment
class | SimpleExperiment1D
class | HaighMallionShiftProcessor
class | HBondShiftProcessor
class | JohnsonBoveyShiftProcessor
class | Peak
class | PeakList
class | RandomCoilShiftProcessor
class | ShiftModel
class | ShiftModel1D
class | ShiftModel2D
class | ShiftModule
class | Spectrum
class | BALLPlugin
class | PluginHandler
class | PluginManager
class | PyColorRGBAVector
class | PyCompositeList
class | Constant
class | PyDatasetVector
class | PyIndexList
class | PyCAPIKernel
class | PyInterpreter
class | PyKernel
class | PyServer
class | AromaticityProcessor
| This processor provides methods for detection and assignment of aromaticity. More...
class | ConnectivityBase
class | ZagrebIndex
class | BalabanIndexJ
class | Descriptor
class | PartialChargeBase
class | TotalPositivePartialCharge
class | TotalNegativePartialCharge
class | RelPositivePartialCharge
class | RelNegativePartialCharge
class | PartialChargeProcessor
class | RingPerceptionProcessor
class | SimpleBase
class | MolecularWeight
class | NumberOfBonds
class | NumberOfSingleBonds
class | NumberOfDoubleBonds
class | NumberOfTripleBonds
class | NumberOfAromaticBonds
class | NumberOfAtoms
class | NumberOfBoron
class | NumberOfCarbon
class | NumberOfNitrogen
class | NumberOfOxygen
class | NumberOfFlourine
class | NumberOfPhosphorus
class | NumberOfSulfur
class | NumberOfChlorine
class | NumberOfBromine
class | NumberOfIodine
class | NumberOfHydrogen
class | FormalCharge
class | NumberOfHeavyAtoms
class | MeanAtomInformationContent
class | AtomInformationContent
class | NumberOfRotatableSingleBonds
class | RelNumberOfRotatableSingleBonds
class | NumberOfAromaticAtoms
class | NumberOfHeavyBonds
class | NumberOfRotatableBonds
class | RelNumberOfRotatableBonds
class | VertexAdjacency
class | VertexAdjacencyEquality
class | NumberOfHydrogenBondAcceptors
class | NumberOfHydrogenBondDonors
class | NumberOfHydrophobicAtoms
class | BondPolarizabilities
class | AtomicPolarizabilities
class | SizeOfSSSR
class | PrincipalMomentOfInertia
class | PrincipalMomentOfInertiaX
class | PrincipalMomentOfInertiaY
class | PrincipalMomentOfInertiaZ
class | SurfaceBase
class | PositiveVdWSurface
class | NegativeVdWSurface
class | PositivePolarVdWSurface
class | NegativePolarVdWSurface
class | HydrophobicVdWSurface
class | PolarVdWSurface
class | RelPositiveVdWSurface
class | RelNegativeVdWSurface
class | RelPositivePolarVdWSurface
class | RelNegativePolarVdWSurface
class | RelHydrophobicVdWSurface
class | RelPolarVdWSurface
class | VdWVolume
class | Density
class | VdWSurface
class | ScoringBaseFunction
class | DiffGridBasedScoring
class | DifferentiableScoringFunction
class | FermiBaseFunction
class | GridBasedScoring
class | LinearBaseFunction
class | Rescorer
class | ScoreGridSet
class | ScoringComponent
class | ScoringFunction
class | ScoringOptimizer
class | AdvancedElectrostatic
class | AromaticRingStacking
class | BurialDepth
class | BuriedPolar
class | CHPI
class | CHPISlick
class | Electrostatic
class | FragmentationalSolvation
class | FresnoTypes
class | HydrogenBond
class | HydrogenBondSlick
class | Lipophilic
class | NonpolarSolvation
class | PB
class | PLP
class | Polarity
class | PolarSolvation
class | RotationalEntropy
class | Solvation
class | VanDerWaals
class | VanDerWaalsSlick
class | AmberEvaluation
class | EnergeticEvaluation
class | ForceFieldEvaluation
class | GridedMM
class | GridedPLP
class | MMScoring
class | PBScoring
class | PLPScoring
class | RandomEvaluation
class | Rescoring
class | Rescoring1D
class | Rescoring3D
class | Rescoring4D
class | SLICKEnergy
class | SLICKScore
class | ClaverieParameter
class | ElectrostaticPotentialCalculator
class | GeneralizedBornModel
class | Pair6_12InteractionEnergyProcessor
class | Pair6_12RDFIntegrator
class | PairExpInteractionEnergyProcessor
class | PairExpRDFIntegrator
class | PCMCavFreeEnergyProcessor
class | PierottiCavFreeEnergyProcessor
class | FDPB
class | ReissCavFreeEnergyProcessor
class | SolventAtomDescriptor
class | SolventDescriptor
class | SolventParameter
class | UhligCavFreeEnergyProcessor
class | AddHydrogenProcessor
class | AssignBondOrderProcessor
| Assignment of bond orders from topology information. More...
class | AtomBijection
class | AtomTyper
class | BinaryFingerprintMethods
| This class provides efficient similarity calculation functionality for 2D binary fingerprints. More...
class | BindingPocketProcessor
class | AStarBondOrderStrategy
class | BondOrderAssignment
| A solution to the bond order assignment problem. More...
class | BondOrderAssignmentStrategy
| Base class for bond order assignment algorithms. More...
class | BranchAndBoundBondOrderStrategy
class | FPTBondOrderStrategy
class | ILPBondOrderStrategy
class | KGreedyBondOrderStrategy
class | PartialBondOrderAssignment
| A full or partial solution to the AStar-based bond order assignment problem. More...
class | BuildBondsProcessor
class | ConnectedComponentsProcessor
| Computation of the connected components of the molecular graph. More...
class | ClearChargeProcessor
class | ClearRadiusProcessor
class | AssignRadiusProcessor
class | AssignChargeProcessor
class | DisulfidBondProcessor
class | DNAMutator
class | FragmentDB
class | BoundingBoxProcessor
class | GeometricCenterProcessor
class | FragmentDistanceCollector
class | TranslationProcessor
class | TransformationProcessor
class | GraphVertex
class | GraphFace
class | GraphTriangle
class | GraphEdge
class | HBondProcessor
| Computation of hydrogen bonds from topology information. More...
class | HybridisationProcessor
class | Kekuliser
class | LogP
class | MolecularSimilarity
class | Mutator
class | NucleotideMapping
class | NumericalSAS
class | PeptideCapProcessor
| This processor adds ACE-N and NME-C caps to proteins. More...
class | RadialDistributionFunction
class | RDFIntegrator
class | RDFParameter
class | RDFSection
class | ReconstructFragmentProcessor
struct | SortedPosition2
struct | SortedPosition3
class | ReducedSurface
class | RSComputer
class | ResidueChecker
class | Rotamer
class | ResidueRotamerSet
class | RGroupAssembler
class | RingAnalyser
| Methods for the analysis of the structure of ringsystems. More...
class | RMSDMinimizer
class | RotamerLibrary
| Rotamer Library Class. More...
class | RSEdge
class | RSFace
class | RSVertex
class | SASEdge
class | SASFace
class | SASVertex
class | SDGenerator
class | SecondaryStructureProcessor
| Secondary structure extraction from 3D structure. More...
class | SESEdge
class | SESFace
class | SESVertex
class | SideChainPlacementProcessor
class | EdgeItem
class | TSimpleMolecularGraph
class | NodeItem
class | SmartsMatcher
class | SmartsParser
class | SmilesParser
class | SolventAccessibleSurface
class | SolventExcludedSurface
class | SESComputer
class | SESSingularityCleaner
class | StructureMapper
class | SurfaceProcessor
class | Triangle
class | TriangleEdge
class | TrianglePoint
class | TriangulatedSAS
class | SASTriangulator
class | TriangulatedSES
class | SESTriangulator
class | TriangulatedSurface
class | TriangulatedSphere
class | UCK
class | BinaryFileAdaptor
class | Directory
class | TransformationManager
class | File
class | FileSystem
class | MPISupport
class | TMutex
class | TMutex< QMutex >
class | TMutexLocker
class | TReadWriteLock
class | TReadWriteLock< QReadWriteLock >
class | TReadLocker
class | TWriteLocker
class | TMutex< boost::mutex >
class | TCPIOStream
class | TCPServer
class | TCPServerThread
class | Path
class | SimpleDownloader
class | Timer
class | CrystalGenerator
class | CrystalInfo
class | SpaceGroupParameters
class | binary_function
class | vector
| STL class. More...

## Typedefs

typedef int(* | ComparatorType) (const void *, const void *)
typedef TContour< float > | Contour
typedef TContourLine< float > | ContourLine
typedef Index | FacetArray[256][12]
typedef TContourSurface< float > | ContourSurface
| Default type.
typedef boost::adjacency_list< boost::vecS, boost::vecS, boost::undirectedS, boost::property< boost::vertex_atom_ptr_t, const Atom * >, boost::property< boost::edge_bond_ptr_t, const Bond * > > | MolecularGraphBase
typedef GRAPH::GraphTraits< MolecularGraph > | MolecularGraphTraits
typedef MolecularGraph::EditableGraph | EditableMolecularGraph
typedef TRegularData1D< float > | RegularData1D
typedef TRegularData2D< float > | RegularData2D
typedef TRegularData3D< float > | RegularData3D
typedef HashSet< String > | StringHashSet
typedef FlexibleMolecule | Ligand
typedef std::list< EnergyProcessor * > | EnergyProcessorList
typedef std::list< Atom * > | AtomList
typedef std::list< Bond * > | BondList
typedef std::list< AtomContainer * > | AtomContainerList
typedef std::list< PDBAtom * > | PDBAtomList
typedef std::list< Residue * > | ResidueList
typedef std::list< Fragment * > | FragmentList
typedef std::list< Molecule * > | MoleculeList
typedef std::list< Protein * > | ProteinList
typedef std::list< SecondaryStructure * > | SecondaryStructureList
typedef std::list< Chain * > | ChainList
typedef std::list< Nucleotide * > | NucleotideList
typedef std::list< NucleicAcid * > | NucleicAcidList
typedef BidirectionalIterator< Composite, Fragment, Composite::CompositeIterator, FragmentIteratorTraits > | FragmentIterator
typedef ConstBidirectionalIterator< Composite, Fragment, Composite::CompositeIterator, FragmentIteratorTraits > | FragmentConstIterator
typedef std::reverse_iterator< FragmentIterator > | FragmentReverseIterator
typedef std::reverse_iterator< FragmentConstIterator > | FragmentConstReverseIterator
typedef BidirectionalIterator< Composite, Molecule, Composite::CompositeIterator, MoleculeIteratorTraits > | MoleculeIterator
typedef ConstBidirectionalIterator< Composite, Molecule, Composite::CompositeIterator, MoleculeIteratorTraits > | MoleculeConstIterator
typedef std::reverse_iterator< MoleculeIterator > | MoleculeReverseIterator
typedef std::reverse_iterator< MoleculeConstIterator > | MoleculeConstReverseIterator
typedef BidirectionalIterator< Composite, NucleicAcid, Composite::CompositeIterator, NucleicAcidIteratorTraits > | NucleicAcidIterator
typedef ConstBidirectionalIterator< Composite, NucleicAcid, Composite::CompositeIterator, NucleicAcidIteratorTraits > | NucleicAcidConstIterator
typedef std::reverse_iterator< NucleicAcidIterator > | NucleicAcidReverseIterator
typedef std::reverse_iterator< NucleicAcidConstIterator > | NucleicAcidConstReverseIterator
typedef BidirectionalIterator< Composite, Nucleotide, Composite::CompositeIterator, NucleotideIteratorTraits > | NucleotideIterator
typedef ConstBidirectionalIterator< Composite, Nucleotide, Composite::CompositeIterator, NucleotideIteratorTraits > | NucleotideConstIterator
typedef std::reverse_iterator< NucleotideIterator > | NucleotideReverseIterator
typedef std::reverse_iterator< NucleotideConstIterator > | NucleotideConstReverseIterator
typedef BidirectionalIterator< Composite, Protein, Composite::CompositeIterator, ProteinIteratorTraits > | ProteinIterator
typedef ConstBidirectionalIterator< Composite, Protein, Composite::CompositeIterator, ProteinIteratorTraits > | ProteinConstIterator
typedef std::reverse_iterator< ProteinIterator > | ProteinReverseIterator
typedef std::reverse_iterator< ProteinConstIterator > | ProteinConstReverseIterator
typedef BidirectionalIterator< Composite, Residue, Composite::CompositeIterator, ResidueIteratorTraits > | ResidueIterator
typedef ConstBidirectionalIterator< Composite, Residue, Composite::CompositeIterator, ResidueIteratorTraits > | ResidueConstIterator
typedef std::reverse_iterator< ResidueIterator > | ResidueReverseIterator
typedef std::reverse_iterator< ResidueConstIterator > | ResidueConstReverseIterator
typedef BidirectionalIterator< Composite, SecondaryStructure, Composite::CompositeIterator, SecondaryStructureIteratorTraits > | SecondaryStructureIterator
typedef ConstBidirectionalIterator< Composite, SecondaryStructure, Composite::CompositeIterator, SecondaryStructureIteratorTraits > | SecondaryStructureConstIterator
typedef std::reverse_iterator< SecondaryStructureIterator > | SecondaryStructureReverseIterator
typedef std::reverse_iterator< SecondaryStructureConstIterator > | SecondaryStructureConstReverseIterator
typedef TAngle< float > | Angle
typedef std::complex< BALL_COMPLEX_PRECISION > | Complex
typedef TFFT1D< BALL_FFTW_DEFAULT_TRAITS > | FFT1D
typedef TFFT2D< BALL_FFTW_DEFAULT_TRAITS > | FFT2D
typedef TFFT3D< BALL_FFTW_DEFAULT_TRAITS > | FFT3D
typedef std::vector< double > | Coefficients
typedef std::pair< double, double > | Interval
typedef TQuaternion< float > | Quaternion
typedef TSurface< float > | Surface
typedef Spectrum< RegularData1D, Peak1D > | Spectrum1D
| One-dimensional spectrum.
typedef Spectrum< RegularData2D, Peak2D > | Spectrum2D
| Two-dimensional spectrum.
typedef Spectrum< RegularData3D, Peak3D > | Spectrum3D
| Three-dimensional spectrum.
typedef std::list< RegularData3D * > | RegularData3DList
using | AtomContainerProcessor = UnaryProcessor<AtomContainer>
using | AtomProcessor = UnaryProcessor<Atom>
using | BondProcessor = UnaryProcessor<Bond>
using | ChainProcessor = UnaryProcessor<Chain>
using | CompositeProcessor = UnaryProcessor<Composite>
using | FragmentProcessor = UnaryProcessor<Fragment>
using | ResidueProcessor = UnaryProcessor<Residue>
using | ConstAtomProcessor = ConstUnaryProcessor<Atom>
using | ConstCompositeProcessor = ConstUnaryProcessor<Composite>
typedef std::vector< Eigen::MatrixXd, Eigen::aligned_allocator< Eigen::MatrixXd > > | MatrixVector
typedef vector< vector< vector< double > > > | ScoreGrid
typedef std::list< std::pair< Atom *, Atom * > > | AtomPairList
typedef std::vector< std::pair< Atom *, Atom * > > | AtomPairVector
typedef TSimpleMolecularGraph< Index, Index > | SimpleMolecularGraph
typedef TMutex< BALL_DEFAULT_MUTEX_TYPE > | Mutex
typedef TReadWriteLock< BALL_DEFAULT_READWRITELOCK_TYPE > | ReadWriteLock
typedef TMutexLocker< BALL_DEFAULT_MUTEXLOCKER_TYPE, BALL_DEFAULT_MUTEX_TYPE > | MutexLocker
typedef TReadLocker< BALL_DEFAULT_READLOCKER_TYPE, BALL_DEFAULT_READWRITELOCK_TYPE > | ReadLocker
typedef TWriteLocker< BALL_DEFAULT_WRITELOCKER_TYPE, BALL_DEFAULT_READWRITELOCK_TYPE > | WriteLocker
Properties
typedef std::vector< NamedProperty >::iterator | NamedPropertyIterator
Iterator type definitions for the various AtomContainerIterators.
typedef BidirectionalIterator< Composite, AtomContainer, Composite::CompositeIterator, AtomContainerIteratorTraits > | AtomContainerIterator
typedef ConstBidirectionalIterator< Composite, AtomContainer, Composite::CompositeIterator, AtomContainerIteratorTraits > | AtomContainerConstIterator
typedef std::reverse_iterator< AtomContainerIterator > | AtomContainerReverseIterator
| A mutable reverse bidirectional iterator for the AtomContainer class.
typedef std::reverse_iterator< AtomContainerConstIterator > | AtomContainerConstReverseIterator
| A constant reverse bidirectional iterator for the AtomContainer class.
Iterator type definitions for the various AtomIterators
typedef BidirectionalIterator< Composite, Atom, Composite::CompositeIterator, AtomIteratorTraits > | AtomIterator
typedef ConstBidirectionalIterator< Composite, Atom, Composite::CompositeIterator, AtomIteratorTraits > | AtomConstIterator
typedef std::reverse_iterator< AtomIterator > | AtomReverseIterator
| A mutable reverse bidirectional iterator for the Atom class.
typedef std::reverse_iterator< AtomConstIterator > | AtomConstReverseIterator
| A constant reverse bidirectional iterator for the Atom class.
Typedefs for the various BondIterators
typedef Atom::BondIterator | AtomBondIterator
typedef Atom::BondConstIterator | AtomBondConstIterator
typedef Atom::BondReverseIterator | AtomBondReverseIterator
typedef Atom::BondConstReverseIterator | AtomBondConstReverseIterator
Iterator type definitions for the various ChainIterators
typedef BidirectionalIterator< Composite, Chain, Composite::CompositeIterator, ChainIteratorTraits > | ChainIterator
| A mutable bidirectional iterator for the Chain class.
typedef ConstBidirectionalIterator< Composite, Chain, Composite::CompositeIterator, ChainIteratorTraits > | ChainConstIterator
| A constant bidirectional iterator for the Chain class.
typedef std::reverse_iterator< ChainIterator > | ChainReverseIterator
| A mutable reverse bidirectional iterator for the Chain class.
typedef std::reverse_iterator< ChainConstIterator > | ChainConstReverseIterator
| A constant reverse bidirectional iterator for the Chain class.
Iterator type definitions for the various PDBAtomIterators
typedef BidirectionalIterator< Composite, PDBAtom, Composite::CompositeIterator, PDBAtomIteratorTraits > | PDBAtomIterator
| A mutable bidirectional iterator for the PDBAtom class.
typedef ConstBidirectionalIterator< Composite, PDBAtom, Composite::CompositeIterator, PDBAtomIteratorTraits > | PDBAtomConstIterator
| A constant bidirectional iterator for the PDBAtom class.
typedef std::reverse_iterator< PDBAtomIterator > | PDBAtomReverseIterator
| A mutable reverse bidirectional iterator for the PDBAtom class.
typedef std::reverse_iterator< PDBAtomConstIterator > | PDBAtomConstReverseIterator
| A constant reverse bidirectional iterator for the PDBAtom class.
KernelPredicates Kernel predicates

This chapter describes a set of unary predicates acting on Composite instances, that can be used to identify the class type of a composite at runtime.

  This predicates are functionally similar to the RTTI:isKindOf function. They decide whether a given composite is an instance of a certain class (or of a class derived thereof). For instance, the application of a MoleculePredicate to a composite will yield true, if the given composite was an instance of Molecule (or Protein , as Protein is derived from Molecule). Otherwise false is returned.

  Each KernelPredicate possesses three methods:

-operator (const Composite&) -operator (const Composite&) const

The two operators are functionally identical (two methods are needed, because the class is derived from TUnaryPredicate and we want to make sure both methods are overwritten). operator() returns true, if the given composite is a kind of the class corresponding to the respective predicate, false otherwise.

See also
  UnaryPredicate
  RTTI

typedef UnaryPredicate< Composite > | KernelPredicateType
Convenience typedefs
typedef Experiment< PeakList1D > | Experiment1D
typedef Experiment< PeakList3D > | Experiment3D
typedef Peak< float > | Peak1D
typedef Peak< Vector2 > | Peak2D
typedef Peak< Vector3 > | Peak3D
Standard typedefs
typedef PeakList< Peak< float > > | PeakList1D
| 1D peak list
typedef PeakList< Peak< Vector2 > > | PeakList2D
| 2D peak list
typedef PeakList< Peak< Vector3 > > | PeakList3D
| 3D peak list

## Functions

BALL_EXPORT std::ostream & | operator<< (std::ostream &os, const Exception::GeneralException &e)
template<class T>
void BALL_DEPRECATED BALL_INLINE | ball_macro_sleepfor (T ms)
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_max (T a, T b)
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_max3 (T a, T b, T c)
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_min (T a, T b)
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_min3 (T a, T b, T c)
template<class X>
int BALL_DEPRECATED BALL_INLINE | ball_macro_abs (X x)
template<class X>
int BALL_DEPRECATED BALL_INLINE | ball_macro_sgn (X x)
template<class X>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_odd (X x)
template<class X>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_int_odd (X x)
template<class X>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_int_even (X x)
template<class X>
X BALL_DEPRECATED BALL_INLINE | ball_macro_real_round (X x)
template<class X, class Y, class E>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_real_equal (X x, Y y, E e)
template<class X, class Y, class E>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_real_not_equal (X x, Y y, E e)
template<class X, class Y, class E>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_real_less (X x, Y y, E e)
template<class X, class Y, class E>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_real_less_or_equal (X x, Y y, E e)
template<class X, class Y, class E>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_real_greater (X x, Y y, E e)
template<class X, class Y, class E>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_real_greater_or_equal (X x, Y y, E e)
template<class X>
X BALL_DEPRECATED BALL_INLINE | ball_macro_real_abs (X x)
template<class X>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_real_odd (X x)
template<class X>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_real_even (X x)
template<class X>
long BALL_DEPRECATED BALL_INLINE | ball_macro_real_floor (X x)
template<class X>
long BALL_DEPRECATED BALL_INLINE | ball_macro_real_ceiling (X x)
template<class X>
int BALL_DEPRECATED BALL_INLINE | ball_macro_real_round_int (X x)
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_char_bits ()
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_char_mask ()
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_char_shift ()
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_all_bits_set ()
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_all_bits_cleared ()
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_number_of_bytes (T x)
template<class T, std::size_t N>
std::size_t BALL_DEPRECATED BALL_INLINE | ball_macro_sizeof_array (T(&)[N])
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_bitarray_size (T x)
template<class BitArray, class X>
void BALL_DEPRECATED BALL_INLINE | ball_macro_bitarray_clear_bit (BitArray *a, X x)
template<class BitArray, class X>
void BALL_DEPRECATED BALL_INLINE | ball_macro_bitarray_set_bit (BitArray *a, X x)
template<class BitArray, class X>
void BALL_DEPRECATED BALL_INLINE | ball_macro_bitarray_toggle_bit (BitArray *a, X x)
template<class BitArray, class X>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_bitarray_is_bit_set (BitArray *a, X x)
template<class Bit>
unsigned BALL_DEPRECATED BALL_INLINE | ball_macro_bit (Bit bit)
template<class Bitset, class Bit>
void BALL_DEPRECATED BALL_INLINE | ball_macro_bit_set (Bitset &bitset, Bit bit)
template<class Bitset>
void BALL_DEPRECATED BALL_INLINE | ball_macro_bit_set_all (Bitset &bitset)
template<class Bitset, class Bit>
void BALL_DEPRECATED BALL_INLINE | ball_macro_bit_set_all_to (Bitset &bitset, Bit bit)
template<class Bitset, class Bit>
void BALL_DEPRECATED BALL_INLINE | ball_macro_bit_set_all_from (Bitset &bitset, Bit bit)
template<class Bitset, class Bit>
void BALL_DEPRECATED BALL_INLINE | ball_macro_bit_clear (Bitset &bitset, Bit bit)
template<class Bitset>
void BALL_DEPRECATED BALL_INLINE | ball_macro_bit_clear_all (Bitset &bitset)
template<class Bitset, class Bit>
void BALL_DEPRECATED BALL_INLINE | ball_macro_bit_clear_all_to (Bitset &bitset, Bit bit)
template<class Bitset, class Bit>
void BALL_DEPRECATED BALL_INLINE | ball_macro_bit_clear_all_from (Bitset &bitset, Bit bit)
template<class Bitset, class Bit>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_bit_is_set (Bitset &bitset, Bit bit)
template<class Bitset, class Bit>
bool BALL_DEPRECATED BALL_INLINE | ball_macro_bit_is_cleared (Bitset &bitset, Bit bit)
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_angle_radians_to_degree (T rad_angle)
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_angle_degree_to_radian (T deg_angle)
template<class T>
T BALL_DEPRECATED BALL_INLINE | ball_macro_generic_echo (T value)
BALL_EXPORT string | streamClassName (const std::type_info &t)
BALL_EXPORT std::ostream & | operator<< (std::ostream &os, const PreciseTime &time)
BALL_EXPORT std::ostream & | operator<< (std::ostream &os, const TimeStamp &stamp)
template<>
BALL_EXPORT HashIndex | Hash (const std::pair< Position, Position > &p)
BALL_EXPORT const FacetArray & | getContourSurfaceFacetData (double threshold)
BALL_EXPORT bool | operator== (const String &s1, const String &s2)
BALL_EXPORT bool | operator!= (const String &s1, const String &s2)
BALL_EXPORT bool | operator< (const String &s1, const String &s2)
BALL_EXPORT bool | operator<= (const String &s1, const String &s2)
BALL_EXPORT bool | operator> (const String &s1, const String &s2)
BALL_EXPORT bool | operator>= (const String &s1, const String &s2)
BALL_EXPORT String | operator+ (const String &s1, const string &s2)
| Concatenates two strings.
BALL_EXPORT String | operator+ (const string &s1, const String &s2)
| Concatenates two strings.
BALL_EXPORT String | operator+ (const String &s1, const String &s2)
| Concatenates two strings.
BALL_EXPORT String | operator+ (const String &s1, const char *char_ptr)
| Concatenates a string and a C type string.
BALL_EXPORT String | operator+ (const char *char_ptr, const String &s)
| Concatenates a C type string and a string.
BALL_EXPORT String | operator+ (const String &s, char c)
| Concatenates a string and a character.
BALL_EXPORT String | operator+ (char c, const String &s)
| Concatenates a character and a string.
BALL_EXPORT String | operator+ (String &&s1, const string &s2)
| Concatenates two strings.
BALL_EXPORT String | operator+ (String &&s1, const String &s2)
| Concatenates two strings.
BALL_EXPORT String | operator+ (String &&s1, String &&s2)
| Concatenates two strings.
BALL_EXPORT String | operator+ (const String &s1, string &&s2)
| Concatenates two strings.
BALL_EXPORT String | operator+ (string &&s1, const String &s2)
| Concatenates two strings.
BALL_EXPORT String | operator+ (const string &s1, String &&s2)
| Concatenates two strings.
BALL_EXPORT String | operator+ (const String &s1, String &&s2)
| Concatenates two strings.
BALL_EXPORT String | operator+ (String &&s1, const char *char_ptr)
| Concatenates a string and a C type string.
BALL_EXPORT String | operator+ (const char *char_ptr, String &&s)
| Concatenates a C type string and a string.
BALL_EXPORT String | operator+ (String &&s, char c)
| Concatenates a string and a character.
BALL_EXPORT String | operator+ (char c, String &&s)
| Concatenates a character and a string.
std::ostream & | operator<< (std::ostream &out, const DockResult &dock_res) throw ()
std::istream & | operator>> (std::istream &in, DockResult &dock_res) throw ()
BALL_EXPORT double | calculateACE (const AtomContainer &atom_container, const string &type_filename="energy/ACE_types.dat", const string &parameter_filename="energy/ACE_parameters.dat")
BALL_EXPORT double | calculateCoulomb (const AtomContainer &atoms)
BALL_EXPORT double | calculateDistanceCoulomb (const AtomContainer &fragment)
BALL_EXPORT HashIndex | Hash (const PDBFile::ResidueQuadruple &quadruple)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const Quadruple< String, PDB::Character, PDB::Integer, PDB::AChar > &)
BALL_EXPORT AtomList | atoms (const AtomContainer &fragment, const String &expression=String())
BALL_EXPORT AtomList | atoms (const AtomList &atoms, const String &expression)
BALL_EXPORT PDBAtomList | PDBAtoms (const AtomContainer &fragment, const String &expression=String())
BALL_EXPORT BondList | bonds (const AtomContainer &fragment, bool selected_only=false)
BALL_EXPORT BondList | bonds (const Atom &atom)
BALL_EXPORT AtomContainerList | atomContainers (const AtomContainer &fragment, bool selected_only=false)
BALL_EXPORT ResidueList | residues (const AtomContainer &fragment, bool selected_only=false)
BALL_EXPORT FragmentList | fragments (const AtomContainer &fragment, bool selected_only=false)
BALL_EXPORT MoleculeList | molecules (const AtomContainer &fragment, bool selected_only=false)
BALL_EXPORT ProteinList | proteins (const AtomContainer &fragment, bool selected_only=false)
BALL_EXPORT SecondaryStructureList | secondaryStructures (const AtomContainer &fragment, bool selected_only=false)
BALL_EXPORT ChainList | chains (const AtomContainer &fragment, bool selected_only=false)
BALL_EXPORT NucleicAcidList | nucleicAcids (const AtomContainer &fragment, bool selected_only=false)
BALL_EXPORT NucleotideList | nucleotides (const AtomContainer &fragment, bool selected_only=false)
template<class AtomContainerType>
void | cloneBonds (const AtomContainerType &atom_container, AtomContainerType &cloned)
template<class NucleotideContainerType>
const Nucleotide * | get5Prime (const NucleotideContainerType &nucleotide_container)
template<class NucleotideContainerType>
const Nucleotide * | get3Prime (const NucleotideContainerType &nucleotide_container)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const Element &element)
template<class ResidueContainerType>
const Residue * | getNTerminal (const ResidueContainerType &residue_container)
template<class ResidueContainerType>
const Residue * | getCTerminal (const ResidueContainerType &residue_container)
template<typename T>
BALL_INLINE T | getDeterminant_ (const T *m, Size dim)
template<typename T>
T | getDeterminant (const T *m, Size dim)
template<typename T>
BALL_INLINE T | getDeterminant2 (const T *m)
template<typename T>
BALL_INLINE T | getDeterminant2 (const T &m00, const T &m01, const T &m10, const T &m11)
template<typename T>
BALL_INLINE T | getDeterminant3 (const T *m)
template<typename T>
BALL_INLINE T | getDeterminant3 (const T &m00, const T &m01, const T &m02, const T &m10, const T &m11, const T &m12, const T &m20, const T &m21, const T &m22)
template<typename T>
bool | SolveSystem (const T *m, T *x, const Size dim)
template<typename T>
BALL_INLINE bool | SolveSystem2 (const T &a1, const T &b1, const T &c1, const T &a2, const T &b2, const T &c2, T &x1, T &x2)
template<typename T>
short | SolveQuadraticEquation (const T &a, const T &b, const T &c, T &x1, T &x2)
template<typename T>
BALL_INLINE TVector3< T > | GetPartition (const TVector3< T > &a, const TVector3< T > &b)
template<typename T>
BALL_INLINE TVector3< T > | GetPartition (const TVector3< T > &a, const TVector3< T > &b, const T &r, const T &s)
template<typename T>
BALL_INLINE T | GetDistance (const TVector3< T > &a, const TVector3< T > &b)
template<typename T>
BALL_INLINE T | GetDistance (const TLine3< T > &line, const TVector3< T > &point)
template<typename T>
BALL_INLINE T | GetDistance (const TVector3< T > &point, const TLine3< T > &line)
template<typename T>
T | GetDistance (const TLine3< T > &a, const TLine3< T > &b)
template<typename T>
BALL_INLINE T | GetDistance (const TVector3< T > &point, const TPlane3< T > &plane)
template<typename T>
BALL_INLINE T | GetDistance (const TPlane3< T > &plane, const TVector3< T > &point)
template<typename T>
BALL_INLINE T | GetDistance (const TLine3< T > &line, const TPlane3< T > &plane)
template<typename T>
BALL_INLINE T | GetDistance (const TPlane3< T > &plane, const TLine3< T > &line)
template<typename T>
BALL_INLINE T | GetDistance (const TPlane3< T > &a, const TPlane3< T > &b)
template<typename T>
BALL_INLINE bool | GetAngle (const TVector3< T > &a, const TVector3< T > &b, TAngle< T > &intersection_angle)
template<typename T>
BALL_INLINE bool | GetAngle (const TLine3< T > &a, const TLine3< T > &b, TAngle< T > &intersection_angle)
template<typename T>
BALL_INLINE bool | GetAngle (const TPlane3< T > &plane, const TVector3< T > &vector, TAngle< T > &intersection_angle)
template<typename T>
BALL_INLINE bool | GetAngle (const TVector3< T > &vector, const TPlane3< T > &plane, TAngle< T > &intersection_angle)
template<typename T>
BALL_INLINE bool | GetAngle (const TPlane3< T > &plane, const TLine3< T > &line, TAngle< T > &intersection_angle)
template<typename T>
BALL_INLINE bool | GetAngle (const TLine3< T > &line, const TPlane3< T > &plane, TAngle< T > &intersection_angle)
template<typename T>
BALL_INLINE bool | GetAngle (const TPlane3< T > &a, const TPlane3< T > &b, TAngle< T > &intersection_angle)
template<typename T>
bool | GetIntersection (const TLine3< T > &a, const TLine3< T > &b, TVector3< T > &point)
template<typename T>
BALL_INLINE bool | GetIntersection (const TPlane3< T > &plane, const TLine3< T > &line, TVector3< T > &intersection_point)
template<typename T>
BALL_INLINE bool | GetIntersection (const TLine3< T > &line, const TPlane3< T > &plane, TVector3< T > &intersection_point)
template<typename T>
bool | GetIntersection (const TPlane3< T > &plane1, const TPlane3< T > &plane2, TLine3< T > &line)
template<typename T>
bool | GetIntersection (const TSphere3< T > &sphere, const TLine3< T > &line, TVector3< T > &intersection_point1, TVector3< T > &intersection_point2)
template<typename T>
BALL_INLINE bool | GetIntersection (const TLine3< T > &line, const TSphere3< T > &sphere, TVector3< T > &intersection_point1, TVector3< T > &intersection_point2)
template<typename T>
bool | GetIntersection (const TSphere3< T > &sphere, const TPlane3< T > &plane, TCircle3< T > &intersection_circle)
template<typename T>
BALL_INLINE bool | GetIntersection (const TPlane3< T > &plane, const TSphere3< T > &sphere, TCircle3< T > &intersection_circle)
template<typename T>
bool | GetIntersection (const TSphere3< T > &a, const TSphere3< T > &b, TCircle3< T > &intersection_circle)
template<class T>
bool | GetIntersection (const TSphere3< T > &s1, const TSphere3< T > &s2, const TSphere3< T > &s3, TVector3< T > &p1, TVector3< T > &p2, bool test=true)
template<typename T>
BALL_INLINE bool | isCollinear (const TVector3< T > &a, const TVector3< T > &b)
template<typename T>
BALL_INLINE bool | isComplanar (const TVector3< T > &a, const TVector3< T > &b, const TVector3< T > &c)
template<typename T>
BALL_INLINE bool | isComplanar (const TVector3< T > &a, const TVector3< T > &b, const TVector3< T > &c, const TVector3< T > &d)
template<typename T>
BALL_INLINE bool | isOrthogonal (const TVector3< T > &a, const TVector3< T > &b)
template<typename T>
BALL_INLINE bool | isOrthogonal (const TVector3< T > &vector, const TLine3< T > &line)
template<typename T>
BALL_INLINE bool | isOrthogonal (const TLine3< T > &line, const TVector3< T > &vector)
template<typename T>
BALL_INLINE bool | isOrthogonal (const TLine3< T > &a, const TLine3< T > &b)
template<typename T>
BALL_INLINE bool | isOrthogonal (const TVector3< T > &vector, const TPlane3< T > &plane)
template<typename T>
BALL_INLINE bool | isOrthogonal (const TPlane3< T > &plane, const TVector3< T > &vector)
template<typename T>
BALL_INLINE bool | isOrthogonal (const TPlane3< T > &a, const TPlane3< T > &b)
template<typename T>
BALL_INLINE bool | isIntersecting (const TVector3< T > &point, const TLine3< T > &line)
template<typename T>
BALL_INLINE bool | isIntersecting (const TLine3< T > &line, const TVector3< T > &point)
template<typename T>
BALL_INLINE bool | isIntersecting (const TLine3< T > &a, const TLine3< T > &b)
template<typename T>
BALL_INLINE bool | isIntersecting (const TVector3< T > &point, const TPlane3< T > &plane)
template<typename T>
BALL_INLINE bool | isIntersecting (const TPlane3< T > &plane, const TVector3< T > &point)
template<typename T>
BALL_INLINE bool | isIntersecting (const TLine3< T > &line, const TPlane3< T > &plane)
template<typename T>
BALL_INLINE bool | isIntersecting (const TPlane3< T > &plane, const TLine3< T > &line)
template<typename T>
BALL_INLINE bool | isIntersecting (const TPlane3< T > &a, const TPlane3< T > &b)
template<typename T>
BALL_INLINE bool | isParallel (const TLine3< T > &line, const TPlane3< T > &plane)
template<typename T>
BALL_INLINE bool | isParallel (const TPlane3< T > &plane, const TLine3< T > &line)
template<typename T>
BALL_INLINE bool | isParallel (const TPlane3< T > &a, const TPlane3< T > &b)
template<typename T>
TAngle< T > | getOrientedAngle (const T &ax, const T &ay, const T &az, const T &bx, const T &by, const T &bz, const T &nx, const T &ny, const T &nz)
template<typename T>
BALL_INLINE TAngle< T > | getOrientedAngle (const TVector3< T > &a, const TVector3< T > &b, const TVector3< T > &normal)
template<typename T>
TAngle< T > | getTorsionAngle (const T &ax, const T &ay, const T &az, const T &bx, const T &by, const T &bz, const T &cx, const T &cy, const T &cz, const T &dx, const T &dy, const T &dz)
template<typename T>
BALL_INLINE TAngle< T > | operator* (const T &val, const TAngle< T > &angle)
template<typename T>
BALL_INLINE TAngle< T > | operator+ (const T &val, const TAngle< T > &angle)
template<typename T>
BALL_INLINE TAngle< T > | operator- (const T &val, const TAngle< T > &angle)
template<typename T>
std::istream & | operator>> (std::istream &s, TAngle< T > &angle)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TAngle< T > &angle)
template<typename ComplexTraits>
const RegularData1D & | operator<< (RegularData1D &to, const TFFT1D< ComplexTraits > &from)
template<typename ComplexTraits>
const TRegularData2D< typename TFFT2D< ComplexTraits >::Complex > & | operator<< (TRegularData2D< typename TFFT2D< ComplexTraits >::Complex > &to, const TFFT2D< ComplexTraits > &from)
template<typename ComplexTraits>
const RegularData2D & | operator<< (RegularData2D &to, const TFFT2D< ComplexTraits > &from)
template<typename ComplexTraits>
const TRegularData3D< typename TFFT3D< ComplexTraits >::Complex > & | operator<< (TRegularData3D< typename TFFT3D< ComplexTraits >::Complex > &to, const TFFT3D< ComplexTraits > &from)
template<typename ComplexTraits>
const RegularData3D & | operator<< (RegularData3D &to, const TFFT3D< ComplexTraits > &from)
template<typename T>
std::istream & | operator>> (std::istream &s, TQuaternion< T > &q)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TQuaternion< T > &q)
::std::ostream & | operator<< (::std::ostream &os, const SnapShot &ss)
| Output stream operator for SnapShots.
::std::istream & | operator>> (::std::istream &is, SnapShot &ss)
| Input stream operator for SnapShots.
Position | getMMFF94Index (Position atom_type1, Position atom_type2)
BALL_EXPORT const RegularData1D & | operator<< (RegularData1D &data, const PeakList1D &peak_list)
template<typename PositionType>
std::ostream & | operator<< (std::ostream &os, const Peak< PositionType > &peak)
std::ostream & | operator<< (std::ostream &os, const BALL::ShiftModel2D &shiftmodel)
template<typename DataT, typename PeakT, typename PositionT>
double | operator- (const Spectrum< DataT, PeakT, PositionT > &s1, const Spectrum< DataT, PeakT, PositionT > &s2)
template<typename DataT, typename PeakT, typename PositionT>
std::ostream & | operator<< (std::ostream &os, const Spectrum< DataT, PeakT, PositionT > &spectrum)
template<typename DataT, typename PeakT, typename PositionT>
std::istream & | operator>> (std::istream &is, Spectrum< DataT, PeakT, PositionT > &spectrum)
PyObject * | pyMapBALLObjectToSip (Composite &object)
BALL_EXPORT void | calculateResidueChiAngles (const Protein &protein, HashMap< const Residue *, float > &residue_angles)
BALL_EXPORT void | calculateResidueChiAngles (const Chain &fragment, HashMap< const Residue *, float > &residue_angles)
BALL_EXPORT float | calculateResidueChiAngles (const Residue &residue)
BALL_EXPORT void | calculateResidueChi2Angles (const Protein &protein, HashMap< const Residue *, float > &residue_angles)
BALL_EXPORT void | calculateResidueChi2Angles (const Chain &fragment, HashMap< const Residue *, float > &residue_angles)
BALL_EXPORT float | calculateResidueChi2Angles (const Residue &residue)
BALL_EXPORT TRegularData3D< char > * | calculateSESGrid (const Vector3 &lower, const Vector3 &upper, float spacing, const System &system, float probe_radius)
BALL_EXPORT TRegularData3D< char > * | calculateSASGrid (const Vector3 &lower, const Vector3 &upper, float spacing, const System &system, float probe_radius)
BALL_EXPORT double | calculateOoiEnergy (AtomContainer &atoms)
BALL_EXPORT float | calculateSESAtomAreas (const AtomContainer &fragment, HashMap< const Atom *, float > &atom_areas, float probe_radius=1.5)
BALL_EXPORT float | calculateSESArea (const AtomContainer &fragment, float probe_radius=1.5)
BALL_EXPORT float | calculateSESVolume (const AtomContainer &fragment, float probe_radius=1.5)
template<typename Node, typename Edge>
std::ostream & | operator<< (std::ostream &os, const TSimpleMolecularGraph< Node, Edge > &G)
template<typename T>
void | swapBytes (T &t)
template<>
BALL_EXPORT void | swapBytes (unsigned short &)
template<>
BALL_EXPORT void | swapBytes (short &)
template<>
BALL_EXPORT void | swapBytes (unsigned int &)
template<>
BALL_EXPORT void | swapBytes (int &)
template<>
BALL_EXPORT void | swapBytes (unsigned long &)
template<>
BALL_EXPORT void | swapBytes (long &)
template<>
BALL_EXPORT void | swapBytes (float &)
template<>
BALL_EXPORT void | swapBytes (double &)
template<typename T>
std::ostream & | operator<< (std::ostream &os, const BinaryFileAdaptor< T > &data)
| Output stream for BinaryFileAdaptors.
template<typename T>
std::istream & | operator>> (std::istream &is, BinaryFileAdaptor< T > &data)
| Input stream for BinaryFileAdaptors.
Specialized Hash Functions.
BALL_EXPORT HashIndex | hashPointer (void *const ptr)
BALL_EXPORT HashIndex | hashString (const char *str)
BALL_EXPORT HashIndex | hashPJWString (const char *str)
BALL_EXPORT HashIndex | hashElfString (const char *str)
template<typename T>
HashIndex | Hash (const T &key)
BALL_EXPORT HashIndex | Hash (const string &s)
BALL_EXPORT HashIndex | Hash (const String &s)
BALL_EXPORT HashIndex | Hash (void *const &ptr)
BALL_EXPORT HashIndex | getNextPrime (HashIndex l)
Generic Constant Random Access Iterator
template<typename Container, typename DataType, typename Position, typename Traits>
ConstRandomAccessIterator< Container, DataType, Position, Traits > | operator+ (Distance distance, const ConstRandomAccessIterator< Container, DataType, Position, Traits > &iterator)
Stream I/O
template<typename ValueType>
std::ostream & | operator<< (std::ostream &os, const TRegularData1D< ValueType > &data)
| Output operator.
template<typename ValueType>
std::istream & | operator>> (std::istream &is, TRegularData1D< ValueType > &grid)
| Input operator.
template<typename ValueType>
std::ostream & | operator<< (std::ostream &os, const TRegularData2D< ValueType > &data)
| Output operator.
template<typename ValueType>
std::istream & | operator>> (std::istream &is, TRegularData2D< ValueType > &grid)
| Input operator.
template<typename ValueType>
std::ostream & | operator<< (std::ostream &os, const TRegularData3D< ValueType > &grid)
| Output operator.
template<typename ValueType>
std::istream & | operator>> (std::istream &is, TRegularData3D< ValueType > &grid)
| Input operator.
Angle Calculation
BALL_EXPORT Angle | calculateTorsionAngle (const Atom &a1, const Atom &a2, const Atom &a3, const Atom &a4)
BALL_EXPORT bool | setTorsionAngle (const Atom &a1, const Atom &a2, Atom &a3, const Atom &a4, Angle angle)
BALL_EXPORT Angle | calculateBondAngle (const Atom &a1, const Atom &a2, const Atom &a3)

## Variables

bool | clone_bonds
BALL_EXPORT PTE_ | PTE
StringHashMap< double * > * | ParsedFunctionConstants
StringHashMap< double(*)(double)> * | ParsedFunctionFunctions
Size | MMFF94_number_atom_types
| hold the maximum number of MMFF94 atom types + 1 (wildcard)
BALL_EXPORT const char | CCONN__INSIDE
BALL_EXPORT const char | CCONN__OUTSIDE
BALL_EXPORT const char | CCONN__INSIDE_PROBE
Log streams

Logging, filtering, and storing messages. Many programs emit warning messages, error messages, or simply informations and remarks to their users. The LogStream class provides a convenient and straight-forward interface to classify these messages according to their importance (via the loglevel), filter and store them in files or write them to streams.

  As the LogStream class is derived from ostream, it behaves as any ostream object. Additionally you may associate streams with each LogStream object that catch only messages of certain loglevels. So the user might decide to redirect all error messages to cerr, all warning messages to cout and all informations to a file.

  Along with each message its time of creation and its loglevel is stored. So the user might also decide to store all errors he got in the last two hours or alike.

  The LogStream class heavily relies on the LogStreamBuf class, which does the actual buffering and storing, but is only of interest if you want to implement a derived class, as the actual user interface is implemented in the LogStream class.

BALL_EXPORT LogStream | Log

## Type aliases defined by BALL.

These predefined types are used in BALL for portability and comprehensibility.

enum

ASCII {
ASCII__BACKSPACE = '\b' , ASCII__BELL = '\a' , ASCII__CARRIAGE_RETURN = '\r' , ASCII__HORIZONTAL_TAB = '\t' ,
ASCII__NEWLINE = '\n' , ASCII__RETURN = ASCII__NEWLINE , ASCII__SPACE = ' ' , ASCII__TAB = ASCII__HORIZONTAL_TAB ,
ASCII__VERTICAL_TAB = '\v' , ASCII__COLON = ':' , ASCII__COMMA = ',' , ASCII__EXCLAMATION_MARK = '!' ,
ASCII__POINT = '.' , ASCII__QUESTION_MARK = '?' , ASCII__SEMICOLON = ';'
}

typedef BALL_INDEX_TYPE | Distance
typedef BALL_SIZE_TYPE | Handle
typedef BALL_INDEX_TYPE | Index
typedef BALL_SIZE_TYPE | Size
typedef time_t | Time
typedef BALL_SIZE_TYPE | HashIndex
typedef BALL_SIZE_TYPE | Position
typedef float | Real
typedef double | DoubleReal
typedef BALL_SIZE_TYPE | Property
typedef BALL_INDEX_TYPE | ErrorCode
typedef unsigned char | Byte
typedef BALL_ULONG64_TYPE | LongSize
typedef BALL_LONG64_TYPE | LongIndex
typedef BALL_POINTERSIZEUINT_TYPE | PointerSizeUInt
static const Distance | INVALID_Distance = std::numeric_limits<Distance>::max()
static const Distance | Distance_MIN = (std::numeric_limits<Distance>::min() + 1)
static const Distance | Distance_MAX = std::numeric_limits<Distance>::max()
static const Handle | INVALID_Handle = std::numeric_limits<Handle>::max()
static const Handle | Handle_MIN = 0
static const Handle | Handle_MAX = std::numeric_limits<Handle>::max() - 1
static const Index | INVALID_Index = -1
static const Index | Index_MIN = 0
static const Index | Index_MAX = std::numeric_limits<Index>::max()
static const Position | INVALID_Position = std::numeric_limits<Position>::max()
static const Position | Position_MIN = 0
static const Position | Position_MAX = std::numeric_limits<Position>::max() - 1
static const Size | INVALID_Size = std::numeric_limits<Size>::max()
static const Size | Size_MIN = 0
static const Size | Size_MAX = std::numeric_limits<Size>::max() - 1

## Storers

typedef TBox3< float > | Box3
typedef TCircle3< float > | Circle3
typedef TLine3< float > | Line3
typedef TMatrix4x4< float > | Matrix4x4
typedef TPlane3< float > | Plane3
typedef TSimpleBox3< float > | SimpleBox3
typedef TSphere3< float > | Sphere3
template<typename T>
std::istream & | operator>> (std::istream &s, TBox3< T > &box)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TBox3< T > &box)
template<typename T>
std::istream & | operator>> (std::istream &s, TCircle3< T > &circle)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TCircle3< T > &circle)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TLine3< T > &line)
template<typename T>
std::istream & | operator>> (std::istream &s, TLine3< T > &line)
template<typename T>
std::istream & | operator>> (std::istream &s, TMatrix4x4< T > &m)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TMatrix4x4< T > &m)
template<typename T>
TMatrix4x4< T > | operator* (const T &scalar, const TMatrix4x4< T > &m)
template<typename T>
TVector3< T > | operator* (const TMatrix4x4< T > &matrix, const TVector3< T > &vector)
template<typename T>
std::istream & | operator>> (std::istream &s, TPlane3< T > &plane)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TPlane3< T > &plane)
template<typename T>
std::istream & | operator>> (std::istream &s, TSimpleBox3< T > &box)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TSimpleBox3< T > &box)
template<typename T>
std::istream & | operator>> (std::istream &s, TSphere3< T > &sphere)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TSphere3< T > &sphere)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const ReducedSurface &rs)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const RSEdge &rsedge)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const RSFace &rsface)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const RSVertex &rsvertex)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const SASEdge &sasedge)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const SASFace &sasface)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const SASVertex &sasvertex)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const SESEdge &sesedge)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const SESFace &sesface)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const SESVertex &sesvertex)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const SolventAccessibleSurface &sas)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const SolventExcludedSurface &ses)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const Triangle &triangle)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const TriangleEdge &edge)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const TrianglePoint &point)
BALL_EXPORT std::ostream & | operator<< (std::ostream &s, const TriangulatedSurface &surface)

## Global binary operator functions for two dimensional vectors.

typedef TVector2< float > | Vector2
template<typename T>
BALL_INLINE TVector2< T > | operator* (const T &scalar, const TVector2< T > &vector)
template<typename T>
std::istream & | operator>> (std::istream &s, TVector2< T > &vector)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TVector2< T > &vector)

## Global binary operators for three-dimensional vectors.

typedef TVector3< float > | Vector3
typedef TVector4< float > | Vector4
template class BALL_EXPORT | TVector3< float >
template<typename T>
BALL_INLINE TVector3< T > | operator* (const T &a, const TVector3< T > &b)
template<typename T>
std::istream & | operator>> (std::istream &s, TVector3< T > &vector)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TVector3< T > &vector)
template<typename T>
BALL_INLINE TVector4< T > | operator+ (const TVector4< T > &a, const TVector4< T > &b)
template<typename T>
BALL_INLINE TVector4< T > | operator- (const TVector4< T > &a, const TVector4< T > &b)
template<typename T>
std::istream & | operator>> (std::istream &s, TVector4< T > &vector)
template<typename T>
std::ostream & | operator<< (std::ostream &s, const TVector4< T > &vector)
template<typename T>
BALL_INLINE TVector4< T > | operator* (const T &scalar, const TVector4< T > &v)
template<typename T>
BALL_INLINE TVector4< T > | operator* (const TVector4< T > &v, const T &scalar)

## Typedef Documentation

## Angle

typedef TAngle<float> BALL::Angle

The Default Angle Type. If double precision is not needed, TAngle<float> should be used. It is predefined as Angle for convenience.

Definition at line 697 of file angle.h.

## AtomBondConstIterator

typedef Atom::BondConstIterator BALL::AtomBondConstIterator

A constant iterator for atom bonds.

Definition at line 27 of file bondIterator.h.

## AtomBondConstReverseIterator

typedef Atom::BondConstReverseIterator BALL::AtomBondConstReverseIterator

A constant reverse iterator for atom bonds.

Definition at line 35 of file bondIterator.h.

## AtomBondIterator

typedef Atom::BondIterator BALL::AtomBondIterator

A mutable iterator for atom bonds.

Definition at line 23 of file bondIterator.h.

## AtomBondReverseIterator

typedef Atom::BondReverseIterator BALL::AtomBondReverseIterator

A mutable reverse iterator for atom bonds.

Definition at line 31 of file bondIterator.h.

## AtomConstIterator

typedef ConstBidirectionalIterator<Composite, Atom, Composite::CompositeIterator, AtomIteratorTraits> BALL::AtomConstIterator

A constant bidirectional iterator for the Atom class.

Definition at line 90 of file atomIterator.h.

## AtomConstReverseIterator

typedef std::reverse_iterator<AtomConstIterator> BALL::AtomConstReverseIterator

A constant reverse bidirectional iterator for the Atom class.

Definition at line 96 of file atomIterator.h.

## AtomContainerConstIterator

typedef ConstBidirectionalIterator<Composite, AtomContainer, Composite::CompositeIterator, AtomContainerIteratorTraits> BALL::AtomContainerConstIterator

A constant bidirectional iterator for the AtomContainer class.

Definition at line 94 of file atomContainerIterator.h.

## AtomContainerConstReverseIterator

typedef std::reverse_iterator<AtomContainerConstIterator> BALL::AtomContainerConstReverseIterator

A constant reverse bidirectional iterator for the AtomContainer class.

Definition at line 100 of file atomContainerIterator.h.

## AtomContainerIterator

typedef BidirectionalIterator<Composite, AtomContainer, Composite::CompositeIterator, AtomContainerIteratorTraits> BALL::AtomContainerIterator

A mutable bidirectional iterator for the AtomContainer class.

Definition at line 88 of file atomContainerIterator.h.

## AtomContainerList

typedef std::list<AtomContainer*> BALL::AtomContainerList

Definition at line 55 of file extractors.h.

## AtomContainerProcessor

using BALL::AtomContainerProcessor = UnaryProcessor<AtomContainer>

Definition at line 8 of file pyUnaryProcessors.h.

## AtomContainerReverseIterator

typedef std::reverse_iterator<AtomContainerIterator> BALL::AtomContainerReverseIterator

A mutable reverse bidirectional iterator for the AtomContainer class.

Definition at line 97 of file atomContainerIterator.h.

## AtomIterator

typedef BidirectionalIterator<Composite, Atom, Composite::CompositeIterator, AtomIteratorTraits> BALL::AtomIterator

A mutable bidirectional iterator for the Atom class.

Definition at line 84 of file atomIterator.h.

## AtomPairList

typedef std::list<std::pair<Atom*, Atom*> > BALL::AtomPairList

Definition at line 23 of file scoringFunction.h.

## AtomPairVector

typedef std::vector<std::pair<Atom*, Atom*> > BALL::AtomPairVector

Definition at line 24 of file scoringFunction.h.

## AtomProcessor

using BALL::AtomProcessor = UnaryProcessor<Atom>

Definition at line 9 of file pyUnaryProcessors.h.

## AtomReverseIterator

typedef std::reverse_iterator<AtomIterator> BALL::AtomReverseIterator

A mutable reverse bidirectional iterator for the Atom class.

Definition at line 93 of file atomIterator.h.

## BondList

typedef std::list<Bond*> BALL::BondList

Definition at line 53 of file extractors.h.

## BondProcessor

using BALL::BondProcessor = UnaryProcessor<Bond>

Definition at line 10 of file pyUnaryProcessors.h.

## Byte

typedef unsigned char BALL::Byte

Byte type. Use this type to represent byte data (8 bit length). A Byte is always unsigned.

  Size: 8 bit

  persistent

Definition at line 183 of file COMMON/global.h.

## ChainConstIterator

typedef ConstBidirectionalIterator<Composite, Chain, Composite::CompositeIterator, ChainIteratorTraits> BALL::ChainConstIterator

A constant bidirectional iterator for the Chain class.

Definition at line 89 of file chainIterator.h.

## ChainConstReverseIterator

typedef std::reverse_iterator<ChainConstIterator> BALL::ChainConstReverseIterator

A constant reverse bidirectional iterator for the Chain class.

Definition at line 95 of file chainIterator.h.

## ChainIterator

typedef BidirectionalIterator<Composite, Chain, Composite::CompositeIterator, ChainIteratorTraits> BALL::ChainIterator

A mutable bidirectional iterator for the Chain class.

Definition at line 85 of file chainIterator.h.

## ChainList

typedef std::list<Chain*> BALL::ChainList

Definition at line 69 of file extractors.h.

## ChainProcessor

using BALL::ChainProcessor = UnaryProcessor<Chain>

Definition at line 11 of file pyUnaryProcessors.h.

## ChainReverseIterator

typedef std::reverse_iterator<ChainIterator> BALL::ChainReverseIterator

A mutable reverse bidirectional iterator for the Chain class.

Definition at line 92 of file chainIterator.h.

## ComparatorType

typedef int(* BALL::ComparatorType) (const void *, const void *)

Definition at line 70 of file COMMON/global.h.

## Complex

typedef std::complex<BALL_COMPLEX_PRECISION> BALL::Complex

Definition at line 21 of file complex.h.

## CompositeProcessor

using BALL::CompositeProcessor = UnaryProcessor<Composite>

Definition at line 12 of file pyUnaryProcessors.h.

## ConstAtomProcessor

using BALL::ConstAtomProcessor = ConstUnaryProcessor<Atom>

Definition at line 16 of file pyUnaryProcessors.h.

## ConstCompositeProcessor

using BALL::ConstCompositeProcessor = ConstUnaryProcessor<Composite>

Definition at line 17 of file pyUnaryProcessors.h.

## ContourLine

typedef TContourLine<float> BALL::ContourLine

Default type

Definition at line 153 of file contourLine.h.

## ContourSurface

typedef TContourSurface<float> BALL::ContourSurface

Default type.

Definition at line 250 of file contourSurface.h.

## Distance

typedef BALL_INDEX_TYPE BALL::Distance

Distance type. Use this type to represent distances in indices. Signed.

  Size: 32 bit

  persistent

Definition at line 86 of file COMMON/global.h.

## DoubleReal

typedef double BALL::DoubleReal

Double-precision real type. Use this type to represent double precision floating point numbers.

  Size: 64 bit

  persistent

Definition at line 156 of file COMMON/global.h.

## EditableMolecularGraph

typedef MolecularGraph::EditableGraph BALL::EditableMolecularGraph

Definition at line 78 of file molecularGraph.h.

## ErrorCode

typedef BALL_INDEX_TYPE BALL::ErrorCode

Error code property type. Use this type to represent (signed) error codes.

  Size: 32 bit

  persistent

See also
  PropertyManager

Definition at line 173 of file COMMON/global.h.

## Experiment1D

typedef Experiment<PeakList1D> BALL::Experiment1D

1D NMR experiment

Definition at line 136 of file experiment.h.

## Experiment3D

typedef Experiment<PeakList3D> BALL::Experiment3D

2D NMR experiment 3D NMR experiment

Definition at line 145 of file experiment.h.

## FacetArray

typedef Index BALL::FacetArray[256][12]

Definition at line 32 of file contourSurface.h.

## FFT1D

typedef TFFT1D<BALL_FFTW_DEFAULT_TRAITS> BALL::FFT1D

Default type

Definition at line 267 of file FFT1D.h.

## FFT2D

typedef TFFT2D<BALL_FFTW_DEFAULT_TRAITS> BALL::FFT2D

Default type

Definition at line 318 of file FFT2D.h.

## FFT3D

typedef TFFT3D<BALL_FFTW_DEFAULT_TRAITS> BALL::FFT3D

Default type

Definition at line 347 of file FFT3D.h.

## FragmentConstIterator

typedef ConstBidirectionalIterator<Composite, Fragment, Composite::CompositeIterator, FragmentIteratorTraits> BALL::FragmentConstIterator

Definition at line 81 of file fragmentIterator.h.

## FragmentConstReverseIterator

typedef std::reverse_iterator<FragmentConstIterator> BALL::FragmentConstReverseIterator

Definition at line 87 of file fragmentIterator.h.

## FragmentIterator

typedef BidirectionalIterator<Composite, Fragment, Composite::CompositeIterator, FragmentIteratorTraits> BALL::FragmentIterator

Definition at line 76 of file fragmentIterator.h.

## FragmentList

typedef std::list<Fragment*> BALL::FragmentList

Definition at line 61 of file extractors.h.

## FragmentProcessor

using BALL::FragmentProcessor = UnaryProcessor<Fragment>

Definition at line 13 of file pyUnaryProcessors.h.

## FragmentReverseIterator

typedef std::reverse_iterator<FragmentIterator> BALL::FragmentReverseIterator

Definition at line 84 of file fragmentIterator.h.

## Handle

typedef BALL_SIZE_TYPE BALL::Handle

Handle type. Use this type to represent handles. Handles are used for the non-ambiguous identification of objects (e.g. object derived from Object ). Handles are unsigned.

  Size: 32 bit

  persistent

Definition at line 96 of file COMMON/global.h.

## HashIndex

typedef BALL_SIZE_TYPE BALL::HashIndex

HashIndex type. Use this type to access the result of a hash functions. HashIndex is unsigned.

  Size: 32 bit

  persistent

Definition at line 131 of file COMMON/global.h.

## Index

typedef BALL_INDEX_TYPE BALL::Index

Index type. Use this type to represent indices (e.g. in strings or other sequences). Theses indices may be signed, contrary to the Size type.

  Size: 32 bit

  persistent

Definition at line 105 of file COMMON/global.h.

## Interval

typedef std::pair<double,double> BALL::Interval

An interval is defined by its limits

Definition at line 23 of file piecewiseFunction.h.

## KernelPredicateType

typedef UnaryPredicate<Composite> BALL::KernelPredicateType

Definition at line 59 of file KERNEL/predicate.h.

## Ligand

typedef FlexibleMolecule BALL::Ligand

Definition at line 121 of file flexibleMolecule.h.

## LongIndex

typedef BALL_LONG64_TYPE BALL::LongIndex

Long signed int type. This type holds unsigned 64 bit numbers and is used to store pointers in a portable fashion (for both 32-bit and 64-bit systems).

  Size: 64 bit

  persistent

Definition at line 201 of file COMMON/global.h.

## LongSize

typedef BALL_ULONG64_TYPE BALL::LongSize

Long unsigned int type. This type holds unsigned 64 bit integer numbers and is used to store pointers in a portable fashion (for both 32-bit and 64-bit systems).

  Size: 64 bit

  persistent

Definition at line 192 of file COMMON/global.h.

## MatrixVector

typedef std::vector<Eigen::MatrixXd, Eigen::aligned_allocator<Eigen::MatrixXd> > BALL::MatrixVector

Definition at line 10 of file QSAR/common.h.

## MolecularGraphBase

typedef boost::adjacency_list<boost::vecS, boost::vecS, boost::undirectedS, boost::property<boost::vertex_atom_ptr_t, const Atom*>, boost::property<boost::edge_bond_ptr_t, const Bond*> > BALL::MolecularGraphBase

Definition at line 30 of file molecularGraph.h.

## MolecularGraphTraits

typedef GRAPH::GraphTraits<MolecularGraph> BALL::MolecularGraphTraits

Definition at line 77 of file molecularGraph.h.

## MoleculeConstIterator

typedef ConstBidirectionalIterator<Composite, Molecule, Composite::CompositeIterator, MoleculeIteratorTraits> BALL::MoleculeConstIterator

Definition at line 70 of file moleculeIterator.h.

## MoleculeConstReverseIterator

typedef std::reverse_iterator<MoleculeConstIterator> BALL::MoleculeConstReverseIterator

Definition at line 76 of file moleculeIterator.h.

## MoleculeIterator

typedef BidirectionalIterator<Composite, Molecule, Composite::CompositeIterator, MoleculeIteratorTraits> BALL::MoleculeIterator

Definition at line 65 of file moleculeIterator.h.

## MoleculeList

typedef std::list<Molecule*> BALL::MoleculeList

Definition at line 63 of file extractors.h.

## MoleculeReverseIterator

typedef std::reverse_iterator<MoleculeIterator> BALL::MoleculeReverseIterator

Definition at line 73 of file moleculeIterator.h.

## Mutex

typedef TMutex<BALL_DEFAULT_MUTEX_TYPE> BALL::Mutex

Definition at line 224 of file mutex.h.

## MutexLocker

typedef TMutexLocker<BALL_DEFAULT_MUTEXLOCKER_TYPE, BALL_DEFAULT_MUTEX_TYPE> BALL::MutexLocker

Definition at line 226 of file mutex.h.

## NamedPropertyIterator

typedef std::vector<NamedProperty>::iterator BALL::NamedPropertyIterator

Definition at line 317 of file property.h.

## NucleicAcidConstIterator

typedef ConstBidirectionalIterator<Composite, NucleicAcid, Composite::CompositeIterator, NucleicAcidIteratorTraits> BALL::NucleicAcidConstIterator

Definition at line 76 of file nucleicAcidIterator.h.

## NucleicAcidConstReverseIterator

typedef std::reverse_iterator<NucleicAcidConstIterator> BALL::NucleicAcidConstReverseIterator

Definition at line 80 of file nucleicAcidIterator.h.

## NucleicAcidIterator

typedef BidirectionalIterator<Composite, NucleicAcid, Composite::CompositeIterator, NucleicAcidIteratorTraits> BALL::NucleicAcidIterator

Definition at line 72 of file nucleicAcidIterator.h.

## NucleicAcidList

typedef std::list<NucleicAcid*> BALL::NucleicAcidList

Definition at line 73 of file extractors.h.

## NucleicAcidReverseIterator

typedef std::reverse_iterator<NucleicAcidIterator> BALL::NucleicAcidReverseIterator

Definition at line 78 of file nucleicAcidIterator.h.

## NucleotideConstIterator

typedef ConstBidirectionalIterator<Composite, Nucleotide, Composite::CompositeIterator, NucleotideIteratorTraits> BALL::NucleotideConstIterator

Definition at line 71 of file nucleotideIterator.h.

## NucleotideConstReverseIterator

typedef std::reverse_iterator<NucleotideConstIterator> BALL::NucleotideConstReverseIterator

Definition at line 75 of file nucleotideIterator.h.

## NucleotideIterator

typedef BidirectionalIterator<Composite, Nucleotide, Composite::CompositeIterator, NucleotideIteratorTraits> BALL::NucleotideIterator

Definition at line 67 of file nucleotideIterator.h.

## NucleotideList

typedef std::list<Nucleotide*> BALL::NucleotideList

Definition at line 71 of file extractors.h.

## NucleotideReverseIterator

typedef std::reverse_iterator<NucleotideIterator> BALL::NucleotideReverseIterator

Definition at line 73 of file nucleotideIterator.h.

## PDBAtomConstIterator

typedef ConstBidirectionalIterator<Composite, PDBAtom, Composite::CompositeIterator, PDBAtomIteratorTraits> BALL::PDBAtomConstIterator

A constant bidirectional iterator for the PDBAtom class.

Definition at line 92 of file PDBAtomIterator.h.

## PDBAtomConstReverseIterator

typedef std::reverse_iterator<PDBAtomConstIterator> BALL::PDBAtomConstReverseIterator

A constant reverse bidirectional iterator for the PDBAtom class.

Definition at line 98 of file PDBAtomIterator.h.

## PDBAtomIterator

typedef BidirectionalIterator<Composite, PDBAtom, Composite::CompositeIterator, PDBAtomIteratorTraits> BALL::PDBAtomIterator

A mutable bidirectional iterator for the PDBAtom class.

Definition at line 88 of file PDBAtomIterator.h.

## PDBAtomList

typedef std::list<PDBAtom*> BALL::PDBAtomList

Definition at line 57 of file extractors.h.

## PDBAtomReverseIterator

typedef std::reverse_iterator<PDBAtomIterator> BALL::PDBAtomReverseIterator

A mutable reverse bidirectional iterator for the PDBAtom class.

Definition at line 95 of file PDBAtomIterator.h.

## Peak1D

typedef Peak<float> BALL::Peak1D

Definition at line 261 of file peak.h.

## Peak2D

typedef Peak<Vector2> BALL::Peak2D

Definition at line 262 of file peak.h.

## Peak3D

typedef Peak<Vector3> BALL::Peak3D

Definition at line 263 of file peak.h.

## PeakList1D

typedef PeakList<Peak<float> > BALL::PeakList1D

1D peak list

Definition at line 125 of file peakList.h.

## PeakList2D

typedef PeakList<Peak<Vector2> > BALL::PeakList2D

2D peak list

Definition at line 128 of file peakList.h.

## PeakList3D

typedef PeakList<Peak<Vector3> > BALL::PeakList3D

3D peak list

Definition at line 131 of file peakList.h.

## PointerSizeUInt

typedef BALL_POINTERSIZEUINT_TYPE BALL::PointerSizeUInt

Unsigned int with the same size as a pointer. Used for internal conversion issues mostly. Size: 32/64 bit (platform dependent)

Definition at line 207 of file COMMON/global.h.

## Position

typedef BALL_SIZE_TYPE BALL::Position

Position type. Use this type to represent positions (e.g. in a container) that cannot be negative (contrary to Index ).

  Size: 32 bit

  persistent

Definition at line 140 of file COMMON/global.h.

## Property

typedef BALL_SIZE_TYPE BALL::Property

Unnamed property type. Use this type to represent (unnamed) properties.

  Size: 32 bit

  persistent

See also
  PropertyManager

Definition at line 165 of file COMMON/global.h.

## ProteinConstIterator

typedef ConstBidirectionalIterator<Composite, Protein, Composite::CompositeIterator, ProteinIteratorTraits> BALL::ProteinConstIterator

Definition at line 71 of file proteinIterator.h.

## ProteinConstReverseIterator

typedef std::reverse_iterator<ProteinConstIterator> BALL::ProteinConstReverseIterator

Definition at line 77 of file proteinIterator.h.

## ProteinIterator

typedef BidirectionalIterator<Composite, Protein, Composite::CompositeIterator,ProteinIteratorTraits> BALL::ProteinIterator

Definition at line 66 of file proteinIterator.h.

## ProteinList

typedef std::list<Protein*> BALL::ProteinList

Definition at line 65 of file extractors.h.

## ProteinReverseIterator

typedef std::reverse_iterator<ProteinIterator> BALL::ProteinReverseIterator

Definition at line 74 of file proteinIterator.h.

## Quaternion

typedef TQuaternion<float> BALL::Quaternion

Definition at line 626 of file quaternion.h.

## ReadLocker

typedef TReadLocker<BALL_DEFAULT_READLOCKER_TYPE, BALL_DEFAULT_READWRITELOCK_TYPE> BALL::ReadLocker

Definition at line 227 of file mutex.h.

## ReadWriteLock

typedef TReadWriteLock<BALL_DEFAULT_READWRITELOCK_TYPE> BALL::ReadWriteLock

Definition at line 225 of file mutex.h.

## Real

typedef float BALL::Real

Real type. Use this type to represent standard floating point numbers.

  Size: 32 bit

  persistent

Definition at line 148 of file COMMON/global.h.

## RegularData1D

typedef TRegularData1D<float> BALL::RegularData1D

Default type

Definition at line 358 of file regularData1D.h.

## RegularData2D

typedef TRegularData2D<float> BALL::RegularData2D

Default type

Definition at line 414 of file regularData2D.h.

## RegularData3D

typedef TRegularData3D<float> BALL::RegularData3D

Default type

Definition at line 515 of file regularData3D.h.

## RegularData3DList

typedef std::list<RegularData3D*> BALL::RegularData3DList

Definition at line 15 of file pyListHelper.h.

## ResidueConstIterator

typedef ConstBidirectionalIterator<Composite, Residue, Composite::CompositeIterator, ResidueIteratorTraits> BALL::ResidueConstIterator

Definition at line 67 of file residueIterator.h.

## ResidueConstReverseIterator

typedef std::reverse_iterator<ResidueConstIterator> BALL::ResidueConstReverseIterator

Definition at line 73 of file residueIterator.h.

## ResidueIterator

typedef BidirectionalIterator<Composite, Residue, Composite::CompositeIterator, ResidueIteratorTraits> BALL::ResidueIterator

Definition at line 62 of file residueIterator.h.

## ResidueList

typedef std::list<Residue*> BALL::ResidueList

Definition at line 59 of file extractors.h.

## ResidueProcessor

using BALL::ResidueProcessor = UnaryProcessor<Residue>

Definition at line 14 of file pyUnaryProcessors.h.

## ResidueReverseIterator

typedef std::reverse_iterator<ResidueIterator> BALL::ResidueReverseIterator

Definition at line 70 of file residueIterator.h.

## ScoreGrid

typedef vector<vector<vector<double> > > BALL::ScoreGrid

Definition at line 17 of file scoreGridSet.h.

## SecondaryStructureConstIterator

typedef ConstBidirectionalIterator<Composite, SecondaryStructure, Composite::CompositeIterator, SecondaryStructureIteratorTraits> BALL::SecondaryStructureConstIterator

Definition at line 75 of file secondaryStructureIterator.h.

## SecondaryStructureConstReverseIterator

typedef std::reverse_iterator<SecondaryStructureConstIterator> BALL::SecondaryStructureConstReverseIterator

Definition at line 81 of file secondaryStructureIterator.h.

## SecondaryStructureIterator

typedef BidirectionalIterator<Composite, SecondaryStructure, Composite::CompositeIterator, SecondaryStructureIteratorTraits> BALL::SecondaryStructureIterator

Definition at line 70 of file secondaryStructureIterator.h.

## SecondaryStructureList

typedef std::list<SecondaryStructure*> BALL::SecondaryStructureList

Definition at line 67 of file extractors.h.

## SecondaryStructureReverseIterator

typedef std::reverse_iterator<SecondaryStructureIterator> BALL::SecondaryStructureReverseIterator

Definition at line 78 of file secondaryStructureIterator.h.

## SimpleMolecularGraph

typedef TSimpleMolecularGraph<Index, Index> BALL::SimpleMolecularGraph

Default molecular graph type. Each edge and node has a label of type Index .

Definition at line 202 of file simpleMolecularGraph.h.

## Size

typedef BALL_SIZE_TYPE BALL::Size

Size type. Use this type to represent sizes of containers, sequences or alike. Variables of type Size are unsigned.

  Size: 32 bit

  persistent

Definition at line 114 of file COMMON/global.h.

## Spectrum2D

typedef Spectrum<RegularData2D, Peak2D> BALL::Spectrum2D

Two-dimensional spectrum.

Definition at line 322 of file spectrum.h.

## Spectrum3D

typedef Spectrum<RegularData3D, Peak3D> BALL::Spectrum3D

Three-dimensional spectrum.

Definition at line 325 of file spectrum.h.

## Time

typedef time_t BALL::Time

Time type. Use this type to represent a point in time (as a replaecement for time_t).

  Size: platform dependent

  not persistent

Definition at line 123 of file COMMON/global.h.

## Vector3

typedef TVector3<float> BALL::Vector3

Default three-dimensional vector class. This is the class used in BALL kernel to represent points, coordinates.

Definition at line 1084 of file vector3.h.

## Vector4

typedef TVector4<float> BALL::Vector4

Default four-dimensional vector type

Definition at line 815 of file vector4.h.

## WriteLocker

typedef TWriteLocker<BALL_DEFAULT_WRITELOCKER_TYPE, BALL_DEFAULT_READWRITELOCK_TYPE> BALL::WriteLocker

Definition at line 228 of file mutex.h.

## Enumeration Type Documentation

## ASCII

enum BALL::ASCII

Enumerator
ASCII__BACKSPACE |
ASCII__BELL |
ASCII__CARRIAGE_RETURN |
ASCII__HORIZONTAL_TAB |
ASCII__NEWLINE |
ASCII__RETURN |
ASCII__SPACE |
ASCII__TAB |
ASCII__VERTICAL_TAB |
ASCII__COLON |
ASCII__COMMA |
ASCII__EXCLAMATION_MARK |
ASCII__POINT |
ASCII__QUESTION_MARK |
ASCII__SEMICOLON |

Definition at line 211 of file COMMON/global.h.

## Function Documentation

## atomContainers()

BALL_EXPORT AtomContainerList BALL::atomContainers | ( | const AtomContainer & | fragment,
|  | bool | selected_only = false )

Extract all base fragments from a kernel data structure.

## atoms()

BALL_EXPORT AtomList BALL::atoms | ( | const AtomList & | atoms,
|  | const String & | expression )

Extract atoms matching an expression. This method extracts all atoms from an atom list
that match the Expression expression.

Parameters

  atoms | the AtomContainer containing the atoms
  expression | the expression that selects the atoms

## ball_macro_abs()

template<class X>

int BALL_DEPRECATED BALL_INLINE BALL::ball_macro_abs | ( | X | x | ) |

Definition at line 50 of file macros.h.

## ball_macro_all_bits_cleared()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_all_bits_cleared | ( |  | ) |

Definition at line 183 of file macros.h.

## ball_macro_all_bits_set()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_all_bits_set | ( |  | ) |

Definition at line 177 of file macros.h.

## ball_macro_angle_degree_to_radian()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_angle_degree_to_radian | ( | T | deg_angle | ) |

Definition at line 315 of file macros.h.

## ball_macro_angle_radians_to_degree()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_angle_radians_to_degree | ( | T | rad_angle | ) |

Definition at line 309 of file macros.h.

## ball_macro_bit()

template<class Bit>

unsigned BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bit | ( | Bit | bit | ) |

Definition at line 243 of file macros.h.

## ball_macro_bit_clear()

template<class Bitset, class Bit>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bit_clear | ( | Bitset & | bitset,
|  | Bit | bit )

Definition at line 273 of file macros.h.

## ball_macro_bit_clear_all()

template<class Bitset>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bit_clear_all | ( | Bitset & | bitset | ) |

Definition at line 279 of file macros.h.

## ball_macro_bit_clear_all_from()

template<class Bitset, class Bit>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bit_clear_all_from | ( | Bitset & | bitset,
|  | Bit | bit )

Definition at line 291 of file macros.h.

## ball_macro_bit_clear_all_to()

template<class Bitset, class Bit>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bit_clear_all_to | ( | Bitset & | bitset,
|  | Bit | bit )

Definition at line 285 of file macros.h.

## ball_macro_bit_is_cleared()

template<class Bitset, class Bit>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bit_is_cleared | ( | Bitset & | bitset,
|  | Bit | bit )

Definition at line 303 of file macros.h.

## ball_macro_bit_is_set()

template<class Bitset, class Bit>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bit_is_set | ( | Bitset & | bitset,
|  | Bit | bit )

Definition at line 297 of file macros.h.

## ball_macro_bit_set()

template<class Bitset, class Bit>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bit_set | ( | Bitset & | bitset,
|  | Bit | bit )

Definition at line 249 of file macros.h.

## ball_macro_bit_set_all()

template<class Bitset>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bit_set_all | ( | Bitset & | bitset | ) |

Definition at line 255 of file macros.h.

## ball_macro_bit_set_all_from()

template<class Bitset, class Bit>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bit_set_all_from | ( | Bitset & | bitset,
|  | Bit | bit )

Definition at line 267 of file macros.h.

## ball_macro_bit_set_all_to()

template<class Bitset, class Bit>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bit_set_all_to | ( | Bitset & | bitset,
|  | Bit | bit )

Definition at line 261 of file macros.h.

## ball_macro_bitarray_clear_bit()

template<class BitArray, class X>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bitarray_clear_bit | ( | BitArray * | a,
|  | X | x )

Definition at line 211 of file macros.h.

## ball_macro_bitarray_is_bit_set()

template<class BitArray, class X>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bitarray_is_bit_set | ( | BitArray * | a,
|  | X | x )

Definition at line 235 of file macros.h.

## ball_macro_bitarray_set_bit()

template<class BitArray, class X>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bitarray_set_bit | ( | BitArray * | a,
|  | X | x )

Definition at line 219 of file macros.h.

## ball_macro_bitarray_size()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bitarray_size | ( | T | x | ) |

Definition at line 203 of file macros.h.

## ball_macro_bitarray_toggle_bit()

template<class BitArray, class X>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_bitarray_toggle_bit | ( | BitArray * | a,
|  | X | x )

Definition at line 227 of file macros.h.

## ball_macro_char_bits()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_char_bits | ( |  | ) |

Definition at line 158 of file macros.h.

## ball_macro_char_mask()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_char_mask | ( |  | ) |

Definition at line 164 of file macros.h.

## ball_macro_char_shift()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_char_shift | ( |  | ) |

Definition at line 170 of file macros.h.

## ball_macro_generic_echo()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_generic_echo | ( | T | value | ) |

Definition at line 321 of file macros.h.

## ball_macro_int_even()

template<class X>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_int_even | ( | X | x | ) |

Definition at line 74 of file macros.h.

## ball_macro_int_odd()

template<class X>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_int_odd | ( | X | x | ) |

Definition at line 68 of file macros.h.

## ball_macro_max()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_max | ( | T | a,
|  | T | b )

Definition at line 26 of file macros.h.

## ball_macro_max3()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_max3 | ( | T | a,
|  | T | b,
|  | T | c )

Definition at line 32 of file macros.h.

## ball_macro_min()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_min | ( | T | a,
|  | T | b )

Definition at line 38 of file macros.h.

## ball_macro_min3()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_min3 | ( | T | a,
|  | T | b,
|  | T | c )

Definition at line 44 of file macros.h.

## ball_macro_number_of_bytes()

template<class T>

T BALL_DEPRECATED BALL_INLINE BALL::ball_macro_number_of_bytes | ( | T | x | ) |

Definition at line 189 of file macros.h.

## ball_macro_odd()

template<class X>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_odd | ( | X | x | ) |

Definition at line 62 of file macros.h.

## ball_macro_real_abs()

template<class X>

X BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_abs | ( | X | x | ) |

Definition at line 122 of file macros.h.

## ball_macro_real_ceiling()

template<class X>

long BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_ceiling | ( | X | x | ) |

Definition at line 146 of file macros.h.

## ball_macro_real_equal()

template<class X, class Y, class E>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_equal | ( | X | x,
|  | Y | y,
|  | E | e )

Definition at line 86 of file macros.h.

## ball_macro_real_even()

template<class X>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_even | ( | X | x | ) |

Definition at line 134 of file macros.h.

## ball_macro_real_floor()

template<class X>

long BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_floor | ( | X | x | ) |

Definition at line 140 of file macros.h.

## ball_macro_real_greater()

template<class X, class Y, class E>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_greater | ( | X | x,
|  | Y | y,
|  | E | e )

Definition at line 110 of file macros.h.

## ball_macro_real_greater_or_equal()

template<class X, class Y, class E>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_greater_or_equal | ( | X | x,
|  | Y | y,
|  | E | e )

Definition at line 116 of file macros.h.

## ball_macro_real_less()

template<class X, class Y, class E>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_less | ( | X | x,
|  | Y | y,
|  | E | e )

Definition at line 98 of file macros.h.

## ball_macro_real_less_or_equal()

template<class X, class Y, class E>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_less_or_equal | ( | X | x,
|  | Y | y,
|  | E | e )

Definition at line 104 of file macros.h.

## ball_macro_real_not_equal()

template<class X, class Y, class E>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_not_equal | ( | X | x,
|  | Y | y,
|  | E | e )

Definition at line 92 of file macros.h.

## ball_macro_real_odd()

template<class X>

bool BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_odd | ( | X | x | ) |

Definition at line 128 of file macros.h.

## ball_macro_real_round()

template<class X>

X BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_round | ( | X | x | ) |

Definition at line 80 of file macros.h.

## ball_macro_real_round_int()

template<class X>

int BALL_DEPRECATED BALL_INLINE BALL::ball_macro_real_round_int | ( | X | x | ) |

Definition at line 152 of file macros.h.

## ball_macro_sgn()

template<class X>

int BALL_DEPRECATED BALL_INLINE BALL::ball_macro_sgn | ( | X | x | ) |

Definition at line 56 of file macros.h.

## ball_macro_sizeof_array()

template<class T, std::size_t N>

std::size_t BALL_DEPRECATED BALL_INLINE BALL::ball_macro_sizeof_array | ( | T(&) | [N] | ) |

Definition at line 197 of file macros.h.

## ball_macro_sleepfor()

template<class T>

void BALL_DEPRECATED BALL_INLINE BALL::ball_macro_sleepfor | ( | T | ms | ) |

Definition at line 20 of file macros.h.

## bonds() [1/2]

BALL_EXPORT BondList BALL::bonds | ( | const Atom & | atom | ) |

Extract all bonds from an atom. This function returns all bonds of an atom.

## bonds() [2/2]

BALL_EXPORT BondList BALL::bonds | ( | const AtomContainer & | fragment,
|  | bool | selected_only = false )

Extract all bonds from a kernel data structure. This function extracts all bonds from the atoms contained in the base fragment. If selected_only is set to true, only bonds are extracted where both atoms are selected.

## calculateBondAngle()

BALL_EXPORT Angle BALL::calculateBondAngle | ( | const Atom & | a1,
|  | const Atom & | a2,
|  | const Atom & | a3 )

Calculate the bond angle between three atoms

Exceptions

  BALL::Exception::IllegalPosition |

## calculateResidueChi2Angles() [1/3]

BALL_EXPORT void BALL::calculateResidueChi2Angles | ( | const Chain & | fragment,
|  | HashMap< const Residue *, float > & | residue_angles )

Calculate the Chi2 Angles for each residue. This method computes the chi2 angle of each residue and stores it in the given hash map.
All angles are in radian. Note, that the hash map is NOT cleaned up, but the results are appended to it.

Parameters

  residue_angles | a hash map containing the chi2 angles of the residues (returned)
  fragment | the kernel object containing the residues

## calculateResidueChi2Angles() [2/3]

BALL_EXPORT void BALL::calculateResidueChi2Angles | ( | const Protein & | protein,
|  | HashMap< const Residue *, float > & | residue_angles )

Calculate the Chi2 Angles for each residue. This method computes the chi2 angle of each residue and stores it in the given hash map.
All angles are in radian. Note, that the hash map is NOT cleaned up, but the results are appended to it.

Parameters

  residue_angles | a hash map containing the chi2 angles the residues (returned)
  fragment | the kernel object containing the residues

## calculateResidueChi2Angles() [3/3]

BALL_EXPORT float BALL::calculateResidueChi2Angles | ( | const Residue & | residue | ) |

Calculate the Chi2 Angles for a given residue in radian. If the given residue has no chi angle, zero is returned.

## calculateResidueChiAngles() [1/3]

BALL_EXPORT void BALL::calculateResidueChiAngles | ( | const Chain & | fragment,
|  | HashMap< const Residue *, float > & | residue_angles )

Calculate the Chi Angles for each residue. This method computes the chi angle of each residue and stores it in the given hash map.
All angles are in radian. Note, that the hash map is NOT cleaned up, but the results are appended to it.

Parameters

  residue_angles | a hash map containing the chi angles of the residues (returned)
  fragment | the kernel object containing the residues

## calculateResidueChiAngles() [2/3]

BALL_EXPORT void BALL::calculateResidueChiAngles | ( | const Protein & | protein,
|  | HashMap< const Residue *, float > & | residue_angles )

Calculate the Chi Angles for each residue. This method computes the chi angle of each residue and stores it in the given hash map.
All angles are in radian. Note, that the hash map is NOT cleaned up, but the results are appended to it.

Parameters

  residue_angles | a hash map containing the chi angles of the residues (returned)
  fragment | the kernel object containing the residues

## calculateResidueChiAngles() [3/3]

BALL_EXPORT float BALL::calculateResidueChiAngles | ( | const Residue & | residue | ) |

Calculate the Chi Angles for a given residue in radian. If the given residue has no chi angle, zero is returned.

## calculateTorsionAngle()

BALL_EXPORT Angle BALL::calculateTorsionAngle | ( | const Atom & | a1,
|  | const Atom & | a2,
|  | const Atom & | a3,
|  | const Atom & | a4 )

Calculate the torsion angle between four atoms

Exceptions

  BALL::Exception::IllegalPosition |

## chains()

BALL_EXPORT ChainList BALL::chains | ( | const AtomContainer & | fragment,
|  | bool | selected_only = false )

Extract all chains from a kernel data structure.

## fragments()

BALL_EXPORT FragmentList BALL::fragments | ( | const AtomContainer & | fragment,
|  | bool | selected_only = false )

Extract all fragments from a kernel data structure.

## get3Prime()

template<class NucleotideContainerType>

const Nucleotide * BALL::get3Prime | ( | const NucleotideContainerType & | nucleotide_container | ) |

Definition at line 338 of file nucleotide.h.

## get5Prime()

template<class NucleotideContainerType>

const Nucleotide * BALL::get5Prime | ( | const NucleotideContainerType & | nucleotide_container | ) |

Definition at line 326 of file nucleotide.h.

## GetAngle() [1/7]

template<typename T>

BALL_INLINE bool BALL::GetAngle | ( | const TLine3< T > & | a,
|  | const TLine3< T > & | b,
|  | TAngle< T > & | intersection_angle )

Get the angle between two lines.

Parameters

  a | the first line
  b | the second line
  intersection_angle | the resulting angle

Returns
  bool, true if an angle can be calculated, otherwise false

Definition at line 570 of file analyticalGeometry.h.

## GetAngle() [2/7]

template<typename T>

BALL_INLINE bool BALL::GetAngle | ( | const TLine3< T > & | line,
|  | const TPlane3< T > & | plane,
|  | TAngle< T > & | intersection_angle )

Get the angle between a line and a plane.

Parameters

  line | the line
  plane | the plane
  intersection_angle | the resulting angle

Returns
  bool, true if an angle can be calculated, otherwise false

Definition at line 647 of file analyticalGeometry.h.

## GetAngle() [3/7]

template<typename T>

BALL_INLINE bool BALL::GetAngle | ( | const TPlane3< T > & | a,
|  | const TPlane3< T > & | b,
|  | TAngle< T > & | intersection_angle )

Get the angle between two planes.

Parameters

  a | the first plane
  b | the second plane
  intersection_angle | the resulting angle

Returns
  bool, true if an angle can be calculated, otherwise false

Definition at line 661 of file analyticalGeometry.h.

## GetAngle() [4/7]

template<typename T>

BALL_INLINE bool BALL::GetAngle | ( | const TPlane3< T > & | plane,
|  | const TLine3< T > & | line,
|  | TAngle< T > & | intersection_angle )

Get the angle between a plane and a line.

Parameters

  plane | the plane
  line | the line
  intersection_angle | the resulting angle

Returns
  bool, true if an angle can be calculated, otherwise false

Definition at line 626 of file analyticalGeometry.h.

## GetAngle() [5/7]

template<typename T>

BALL_INLINE bool BALL::GetAngle | ( | const TPlane3< T > & | plane,
|  | const TVector3< T > & | vector,
|  | TAngle< T > & | intersection_angle )

Get the angle between a plane and a Vector3.

Parameters

  plane | the plane
  vector | the Vector3
  intersection_angle | the resulting angle

Returns
  bool, true if an angle can be calculated, otherwise false

Definition at line 590 of file analyticalGeometry.h.

## GetAngle() [6/7]

template<typename T>

BALL_INLINE bool BALL::GetAngle | ( | const TVector3< T > & | a,
|  | const TVector3< T > & | b,
|  | TAngle< T > & | intersection_angle )

Get the angle between two Vector3.

Parameters

  a | the first vector
  b | the second vector
  intersection_angle | the resulting angle

Returns
  bool, always true

Definition at line 551 of file analyticalGeometry.h.

## GetAngle() [7/7]

template<typename T>

BALL_INLINE bool BALL::GetAngle | ( | const TVector3< T > & | vector,
|  | const TPlane3< T > & | plane,
|  | TAngle< T > & | intersection_angle )

Get the angle between a vector3 and a plane.

Parameters

  vector | the vector3
  plane | the plane
  intersection_angle | the resulting angle

Returns
  bool, true if an angle can be calculated, otherwise false

Definition at line 613 of file analyticalGeometry.h.

## getContourSurfaceFacetData()

BALL_EXPORT const FacetArray & BALL::getContourSurfaceFacetData | ( | double | threshold | ) |

extern

## getCTerminal()

template<class ResidueContainerType>

const Residue * BALL::getCTerminal | ( | const ResidueContainerType & | residue_container | ) |

Definition at line 472 of file residue.h.

## getDeterminant()

template<typename T>

T BALL::getDeterminant | ( | const T * | m,
|  | Size | dim )

Get the determinant of any matrix.

Parameters

  m | pointer to matrix
  dim | dimension of the matrix

Definition at line 93 of file analyticalGeometry.h.

## getDeterminant2() [1/2]

template<typename T>

BALL_INLINE T BALL::getDeterminant2 | ( | const T & | m00,
|  | const T & | m01,
|  | const T & | m10,
|  | const T & | m11 )

Get the determinant of an 2x2 matrix.

Parameters

  m00 | first value of the matrix
  m01 | second value of the matrix
  m10 | third value of the matrix
  m11 | fourth value of the matrix

Definition at line 133 of file analyticalGeometry.h.

## getDeterminant2() [2/2]

template<typename T>

BALL_INLINE T BALL::getDeterminant2 | ( | const T * | m | ) |

Get the determinant of an 2x2 matrix.

Parameters

  m | pointer to matrix

Definition at line 119 of file analyticalGeometry.h.

## getDeterminant3() [1/2]

template<typename T>

BALL_INLINE T BALL::getDeterminant3 | ( | const T & | m00,
|  | const T & | m01,
|  | const T & | m02,
|  | const T & | m10,
|  | const T & | m11,
|  | const T & | m12,
|  | const T & | m20,
|  | const T & | m21,
|  | const T & | m22 )

Get the determinant of an 3x3 matrix.

Parameters

  m00,m01,m02,m10,m11,m12,m20,m21,m22 | the elements of the matrix

Definition at line 159 of file analyticalGeometry.h.

## getDeterminant3() [2/2]

template<typename T>

BALL_INLINE T BALL::getDeterminant3 | ( | const T * | m | ) |

Get the determinant of an 3x3 matrix.

Parameters

  m | pointer to matrix

Definition at line 143 of file analyticalGeometry.h.

## getDeterminant_()

template<typename T>

BALL_INLINE T BALL::getDeterminant_ | ( | const T * | m,
|  | Size | dim )

Subroutine to get the determinant of any matrix. Direct usage of this function should be avoided. Instead use T getDeterminant(const T* m, Size dim)

Parameters

  m | pointer to matrix
  dim | dimension of the matrix

Definition at line 57 of file analyticalGeometry.h.

## GetDistance() [1/9]

template<typename T>

T BALL::GetDistance | ( | const TLine3< T > & | a,
|  | const TLine3< T > & | b )

Get the distance between two lines.

Parameters

  a | the first line
  b | the second line

Returns
  T the distance

Exceptions

  Exception::DivisionByZero | if the lines are parallel and a has length 0

Definition at line 433 of file analyticalGeometry.h.

## GetDistance() [2/9]

template<typename T>

BALL_INLINE T BALL::GetDistance | ( | const TLine3< T > & | line,
|  | const TPlane3< T > & | plane )

Get the distance between a line and a plane.

Parameters

  line | the line
  plane | the plane

Returns
  T the distance

Exceptions

  Exception::DivisionByZero | if the normal vector of plane has zero length

Definition at line 502 of file analyticalGeometry.h.

## GetDistance() [3/9]

template<typename T>

BALL_INLINE T BALL::GetDistance | ( | const TLine3< T > & | line,
|  | const TVector3< T > & | point )

Get the distance between a line and a point.

Parameters

  line | the line
  point | the point

Returns
  T the distance

Exceptions

  Exception::DivisionByZero | if the line has length 0

Definition at line 404 of file analyticalGeometry.h.

## GetDistance() [4/9]

template<typename T>

BALL_INLINE T BALL::GetDistance | ( | const TPlane3< T > & | a,
|  | const TPlane3< T > & | b )

Get the distance between two planes.

Parameters

  a | the first plane
  b | the second plane

Returns
  T the distance

Exceptions

  Exception::DivisionByZero | if the normal vector of a has zero length

Definition at line 533 of file analyticalGeometry.h.

## GetDistance() [5/9]

template<typename T>

BALL_INLINE T BALL::GetDistance | ( | const TPlane3< T > & | plane,
|  | const TLine3< T > & | line )

Get the distance between a plane and a line.

Parameters

  plane | the plane
  line | the line

Returns
  T the distance

Exceptions

  Exception::DivisionByZero | if the normal vector of plane has zero length

Definition at line 520 of file analyticalGeometry.h.

## GetDistance() [6/9]

template<typename T>

BALL_INLINE T BALL::GetDistance | ( | const TPlane3< T > & | plane,
|  | const TVector3< T > & | point )

Get the distance between a plane and a point.

Parameters

  plane | the plane
  point | the point

Returns
  T the distance

Exceptions

  Exception::DivisionByZero | if the normal vector of plane has zero length

Definition at line 489 of file analyticalGeometry.h.

## GetDistance() [7/9]

template<typename T>

BALL_INLINE T BALL::GetDistance | ( | const TVector3< T > & | a,
|  | const TVector3< T > & | b )

Get the distance between two points.

Parameters

  a | the first point
  b | the second point

Returns
  T the distance

Definition at line 387 of file analyticalGeometry.h.

## GetDistance() [8/9]

template<typename T>

BALL_INLINE T BALL::GetDistance | ( | const TVector3< T > & | point,
|  | const TLine3< T > & | line )

Get the distance between a point and a line.

Parameters

  point | the point
  line | the line

Returns
  T the distance

Exceptions

  Exception::DivisionByZero | if the line has length 0

Definition at line 421 of file analyticalGeometry.h.

## GetDistance() [9/9]

template<typename T>

BALL_INLINE T BALL::GetDistance | ( | const TVector3< T > & | point,
|  | const TPlane3< T > & | plane )

Get the distance between a point and a plane.

Parameters

  point | the point
  plane | the plane

Returns
  T the distance

Exceptions

  Exception::DivisionByZero | if the normal vector of plane has zero length

Definition at line 470 of file analyticalGeometry.h.

## GetIntersection() [1/10]

template<typename T>

bool BALL::GetIntersection | ( | const TLine3< T > & | a,
|  | const TLine3< T > & | b,
|  | TVector3< T > & | point )

Get the intersection point between two lines.

Parameters

  a | the first line
  b | the second line
  point | the resulting intersection

Returns
  bool, true if an intersection can be calculated, otherwise false

Definition at line 681 of file analyticalGeometry.h.

## GetIntersection() [2/10]

template<typename T>

BALL_INLINE bool BALL::GetIntersection | ( | const TLine3< T > & | line,
|  | const TPlane3< T > & | plane,
|  | TVector3< T > & | intersection_point )

Get the intersection point between a line and a plane.

Parameters

  line | the line
  plane | the plane
  intersection_point | the resulting intersection

Returns
  bool, true if an intersection can be calculated, otherwise false

Definition at line 720 of file analyticalGeometry.h.

## GetIntersection() [3/10]

template<typename T>

BALL_INLINE bool BALL::GetIntersection | ( | const TLine3< T > & | line,
|  | const TSphere3< T > & | sphere,
|  | TVector3< T > & | intersection_point1,
|  | TVector3< T > & | intersection_point2 )

Get the intersection point between a line and a sphere.

Parameters

  line | the line
  sphere | the sphere
  intersection_point1 | the first intersection point
  intersection_point2 | the second intersection point

Returns
  bool, true if an intersection can be calculated, otherwise false

Definition at line 824 of file analyticalGeometry.h.

## GetIntersection() [4/10]

template<typename T>

BALL_INLINE bool BALL::GetIntersection | ( | const TPlane3< T > & | plane,
|  | const TLine3< T > & | line,
|  | TVector3< T > & | intersection_point )

Get the intersection point between a plane and a line.

Parameters

  plane | the plane
  line | the line
  intersection_point | the resulting intersection

Returns
  bool, true if an intersection can be calculated, otherwise false

Definition at line 701 of file analyticalGeometry.h.

## GetIntersection() [5/10]

template<typename T>

BALL_INLINE bool BALL::GetIntersection | ( | const TPlane3< T > & | plane,
|  | const TSphere3< T > & | sphere,
|  | TCircle3< T > & | intersection_circle )

Get the intersection circle between a plane and a sphere.

Parameters

  plane | the plane
  sphere | the sphere
  intersection_circle | the intersection circle

Returns
  bool, true if an intersection can be calculated, otherwise false

Definition at line 870 of file analyticalGeometry.h.

## GetIntersection() [6/10]

template<typename T>

bool BALL::GetIntersection | ( | const TPlane3< T > & | plane1,
|  | const TPlane3< T > & | plane2,
|  | TLine3< T > & | line )

Get the intersection line between two planes.

Parameters

  plane1 | the first plane
  plane2 | the second plane
  line | the resulting intersection

Returns
  bool, true if an intersection can be calculated, otherwise false

Definition at line 732 of file analyticalGeometry.h.

## GetIntersection() [7/10]

template<typename T>

bool BALL::GetIntersection | ( | const TSphere3< T > & | a,
|  | const TSphere3< T > & | b,
|  | TCircle3< T > & | intersection_circle )

Get the intersection circle between two spheres. This methods returns false, if the two spheres are identical, since then no intersection circle exists.

Parameters

  a | the first sphere
  b | the second sphere
  intersection_circle | the intersection circle

Returns
  bool, true if an intersection can be calculated, otherwise false

Definition at line 884 of file analyticalGeometry.h.

## GetIntersection() [8/10]

template<class T>

bool BALL::GetIntersection | ( | const TSphere3< T > & | s1,
|  | const TSphere3< T > & | s2,
|  | const TSphere3< T > & | s3,
|  | TVector3< T > & | p1,
|  | TVector3< T > & | p2,
|  | bool | test = true )

Get the intersection points between three spheres.

Parameters

  s1 | the first sphere
  s2 | the second sphere
  s3 | the third sphere
  p1 | the first intersection point
  p2 | the second intersection point
  test |

Returns
  bool, true if an intersection can be calculated, otherwise false

Definition at line 929 of file analyticalGeometry.h.

## GetIntersection() [9/10]

template<typename T>

bool BALL::GetIntersection | ( | const TSphere3< T > & | sphere,
|  | const TLine3< T > & | line,
|  | TVector3< T > & | intersection_point1,
|  | TVector3< T > & | intersection_point2 )

Get the intersection point between a sphere and a line.

Parameters

  sphere | the sphere
  line | the line
  intersection_point1 | the first intersection point
  intersection_point2 | the second intersection point

Returns
  bool, true if an intersection can be calculated, otherwise false

Definition at line 799 of file analyticalGeometry.h.

## GetIntersection() [10/10]

template<typename T>

bool BALL::GetIntersection | ( | const TSphere3< T > & | sphere,
|  | const TPlane3< T > & | plane,
|  | TCircle3< T > & | intersection_circle )

Get the intersection circle between a sphere and a plane.

Parameters

  sphere | the sphere
  plane | the plane
  intersection_circle | the intersection circle

Returns
  bool, true if an intersection can be calculated, otherwise false

Definition at line 836 of file analyticalGeometry.h.

## getMMFF94Index()

Position BALL::getMMFF94Index | ( | Position | atom_type1,
|  | Position | atom_type2 )

## getNextPrime()

BALL_EXPORT HashIndex BALL::getNextPrime | ( | HashIndex | l | ) |

Calculate the next prime number. This method returns the first prime number that is greater or equal to the number given as the argument. Only odd prime numbers are returned, the lowest number returned is 3.

## getNTerminal()

template<class ResidueContainerType>

const Residue * BALL::getNTerminal | ( | const ResidueContainerType & | residue_container | ) |

Definition at line 457 of file residue.h.

## getOrientedAngle() [1/2]

template<typename T>

TAngle< T > BALL::getOrientedAngle | ( | const T & | ax,
|  | const T & | ay,
|  | const T & | az,
|  | const T & | bx,
|  | const T & | by,
|  | const T & | bz,
|  | const T & | nx,
|  | const T & | ny,
|  | const T & | nz )

Return the oriented angle of two vectors with a normal vector.

Exceptions

  Exception::DivisionByZero | if at least one vector is zero

Definition at line 1259 of file analyticalGeometry.h.

## getOrientedAngle() [2/2]

template<typename T>

BALL_INLINE TAngle< T > BALL::getOrientedAngle | ( | const TVector3< T > & | a,
|  | const TVector3< T > & | b,
|  | const TVector3< T > & | normal )

Return the oriented angle of two vectors with a normal vector.

Exceptions

  Exception::DivisionByZero | if at least one vector is zero

Definition at line 1301 of file analyticalGeometry.h.

## GetPartition() [1/2]

template<typename T>

BALL_INLINE TVector3< T > BALL::GetPartition | ( | const TVector3< T > & | a,
|  | const TVector3< T > & | b )

Get the partition of two vectors.

Parameters

  a | the first vector
  b | the second vector

Returns
  TVector3 the partition

Definition at line 351 of file analyticalGeometry.h.

## GetPartition() [2/2]

template<typename T>

BALL_INLINE TVector3< T > BALL::GetPartition | ( | const TVector3< T > & | a,
|  | const TVector3< T > & | b,
|  | const T & | r,
|  | const T & | s )

Get the partition of two vectors, calculated with two ratio factors.

Parameters

  a | the first vector
  b | the second vector
  r | the ratio factor of the first vector
  s | the ratio factor of the second vector

Returns
  TVector3 the partition

Exceptions

  Exception::DivisionByZero | if r+s == 0

Definition at line 367 of file analyticalGeometry.h.

## getTorsionAngle()

template<typename T>

TAngle< T > BALL::getTorsionAngle | ( | const T & | ax,
|  | const T & | ay,
|  | const T & | az,
|  | const T & | bx,
|  | const T & | by,
|  | const T & | bz,
|  | const T & | cx,
|  | const T & | cy,
|  | const T & | cz,
|  | const T & | dx,
|  | const T & | dy,
|  | const T & | dz )

Return the torsion angle of four points to each other.

Parameters

  ax | 1. vector x component
  ay | 1. vector y component
  az | 1. vector z component
  bx | 2. vector x component
  by | 2. vector y component
  bz | 2. vector z component
  cx | 3. vector x component
  cy | 3. vector y component
  cz | 3. vector z component
  dx | 4. vector x component
  dy | 4. vector y component
  dz | 4. vector z component

Returns
  TAngle the torsion angle

Exceptions

  Exception::DivisionByZero | if one of the outer vectors is collinear with the middle one

Definition at line 1323 of file analyticalGeometry.h.

## Hash() [1/5]

template<>

BALL_EXPORT HashIndex BALL::Hash | ( | const std::pair< Position, Position > & | p | ) |

## Hash() [2/5]

BALL_EXPORT HashIndex BALL::Hash | ( | const String & | s | ) |

inline

String hash function. This method is optimized for the hashing of BALL strings. In fact, it is only an inline wrapper around hashString .

Definition at line 65 of file hash.h.

## Hash() [3/5]

BALL_EXPORT HashIndex BALL::Hash | ( | const string & | s | ) |

inline

String hash function. This method is optimized for the hashing of STL strings. In fact, it is only an inline wrapper around hashString .

Definition at line 56 of file hash.h.

## Hash() [4/5]

template<typename T>

HashIndex BALL::Hash | ( | const T & | key | ) |

inline

General default hash function. This method converts a given key to a HashIndex by calling (HashIndex)key. If the key type T is not convertible to HashIndex by default, a converter should be defined (operator HashIndex).

Parameters

  key | the key to be hashed

Returns
  HashIndex the hash index

Definition at line 47 of file hash.h.

## Hash() [5/5]

BALL_EXPORT HashIndex BALL::Hash | ( | void *const & | ptr | ) |

inline

Pointer hash function. Use this function to hash pointers to objects.

Definition at line 73 of file hash.h.

## hashElfString()

BALL_EXPORT HashIndex BALL::hashElfString | ( | const char * | str | ) |

extern

## hashPJWString()

BALL_EXPORT HashIndex BALL::hashPJWString | ( | const char * | str | ) |

extern

## hashPointer()

BALL_EXPORT HashIndex BALL::hashPointer | ( | void *const | ptr | ) |

extern

## hashString()

BALL_EXPORT HashIndex BALL::hashString | ( | const char * | str | ) |

extern

## isCollinear()

template<typename T>

BALL_INLINE bool BALL::isCollinear | ( | const TVector3< T > & | a,
|  | const TVector3< T > & | b )

Test whether two vector3 are collinear

Parameters

  a | the first vector3
  b | the second vector3

Returns
  bool, true or false

Definition at line 1007 of file analyticalGeometry.h.

## isComplanar() [1/2]

template<typename T>

BALL_INLINE bool BALL::isComplanar | ( | const TVector3< T > & | a,
|  | const TVector3< T > & | b,
|  | const TVector3< T > & | c )

Test whether three vector3 are complanar

Parameters

  a | the first vector3
  b | the second vector3
  c | the third vector3

Returns
  bool, true or false

Definition at line 1020 of file analyticalGeometry.h.

## isComplanar() [2/2]

template<typename T>

BALL_INLINE bool BALL::isComplanar | ( | const TVector3< T > & | a,
|  | const TVector3< T > & | b,
|  | const TVector3< T > & | c,
|  | const TVector3< T > & | d )

Test whether four vector3 are complanar

Parameters

  a | the first vector3
  b | the second vector3
  c | the third vector3
  d | the fourth vector3

Returns
  bool, true or false

Definition at line 1034 of file analyticalGeometry.h.

## isIntersecting() [1/8]

template<typename T>

BALL_INLINE bool BALL::isIntersecting | ( | const TLine3< T > & | a,
|  | const TLine3< T > & | b )

Test whether two lines are intersecting.

Parameters

  a | the first line
  b | the second line

Returns
  bool, true or false

Definition at line 1154 of file analyticalGeometry.h.

## isIntersecting() [2/8]

template<typename T>

BALL_INLINE bool BALL::isIntersecting | ( | const TLine3< T > & | line,
|  | const TPlane3< T > & | plane )

Test whether a line is intersecting a plane.

Parameters

  line | the line
  plane | the plane

Returns
  bool, true or false

Definition at line 1190 of file analyticalGeometry.h.

## isIntersecting() [3/8]

template<typename T>

BALL_INLINE bool BALL::isIntersecting | ( | const TLine3< T > & | line,
|  | const TVector3< T > & | point )

Test whether a line is intersecting a point.

Parameters

  line | the line
  point | the point

Returns
  bool, true or false

Definition at line 1142 of file analyticalGeometry.h.

## isIntersecting() [4/8]

template<typename T>

BALL_INLINE bool BALL::isIntersecting | ( | const TPlane3< T > & | a,
|  | const TPlane3< T > & | b )

Test whether two planes are intersecting.

Parameters

  a | the first plane
  b | the second plane

Returns
  bool, true or false

Definition at line 1214 of file analyticalGeometry.h.

## isIntersecting() [5/8]

template<typename T>

BALL_INLINE bool BALL::isIntersecting | ( | const TPlane3< T > & | plane,
|  | const TLine3< T > & | line )

Test whether a plane is intersecting a line.

Parameters

  plane | the plane
  line | the line

Returns
  bool, true or false

Definition at line 1202 of file analyticalGeometry.h.

## isIntersecting() [6/8]

template<typename T>

BALL_INLINE bool BALL::isIntersecting | ( | const TPlane3< T > & | plane,
|  | const TVector3< T > & | point )

Test whether a point lies in a plane.

Parameters

  plane | the plane
  point | the point

Returns
  bool, true or false

Definition at line 1178 of file analyticalGeometry.h.

## isIntersecting() [7/8]

template<typename T>

BALL_INLINE bool BALL::isIntersecting | ( | const TVector3< T > & | point,
|  | const TLine3< T > & | line )

Test whether a line is intersecting a point.

Parameters

  point | the point
  line | the line

Returns
  bool, true or false

Definition at line 1130 of file analyticalGeometry.h.

## isIntersecting() [8/8]

template<typename T>

BALL_INLINE bool BALL::isIntersecting | ( | const TVector3< T > & | point,
|  | const TPlane3< T > & | plane )

Test whether a point lies in a plane.

Parameters

  point | the point
  plane | the plane

Returns
  bool, true or false

Definition at line 1166 of file analyticalGeometry.h.

## isOrthogonal() [1/7]

template<typename T>

BALL_INLINE bool BALL::isOrthogonal | ( | const TLine3< T > & | a,
|  | const TLine3< T > & | b )

Test whether two lines are orthogonal.

Parameters

  a | the first line
  b | the second line

Returns
  bool, true or false

Definition at line 1082 of file analyticalGeometry.h.

## isOrthogonal() [2/7]

template<typename T>

BALL_INLINE bool BALL::isOrthogonal | ( | const TLine3< T > & | line,
|  | const TVector3< T > & | vector )

Test whether a line and a vector3 are orthogonal

Parameters

  line | the line
  vector | the vector

Returns
  bool, true or false

Definition at line 1070 of file analyticalGeometry.h.

## isOrthogonal() [3/7]

template<typename T>

BALL_INLINE bool BALL::isOrthogonal | ( | const TPlane3< T > & | a,
|  | const TPlane3< T > & | b )

Test whether two planes are orthogonal.

Parameters

  a | the first plane
  b | the second plane

Returns
  bool, true or false

Definition at line 1118 of file analyticalGeometry.h.

## isOrthogonal() [4/7]

template<typename T>

BALL_INLINE bool BALL::isOrthogonal | ( | const TPlane3< T > & | plane,
|  | const TVector3< T > & | vector )

Test whether a plane and a vector3 are orthogonal.

Parameters

  plane | the plane
  vector | the vector3

Returns
  bool, true or false

Definition at line 1106 of file analyticalGeometry.h.

## isOrthogonal() [5/7]

template<typename T>

BALL_INLINE bool BALL::isOrthogonal | ( | const TVector3< T > & | a,
|  | const TVector3< T > & | b )

Test whether two vector3 are orthogonal

Parameters

  a | the first vector3
  b | the second vector3

Returns
  bool, true or false

Definition at line 1046 of file analyticalGeometry.h.

## isOrthogonal() [6/7]

template<typename T>

BALL_INLINE bool BALL::isOrthogonal | ( | const TVector3< T > & | vector,
|  | const TLine3< T > & | line )

Test whether a vector3 and a line are orthogonal

Parameters

  vector | the vector
  line | the line

Returns
  bool, true or false

Definition at line 1058 of file analyticalGeometry.h.

## isOrthogonal() [7/7]

template<typename T>

BALL_INLINE bool BALL::isOrthogonal | ( | const TVector3< T > & | vector,
|  | const TPlane3< T > & | plane )

Test whether a vector3 and a plane are orthogonal.

Parameters

  vector | the vector3
  plane | the plane

Returns
  bool, true or false

Definition at line 1094 of file analyticalGeometry.h.

## isParallel() [1/3]

template<typename T>

BALL_INLINE bool BALL::isParallel | ( | const TLine3< T > & | line,
|  | const TPlane3< T > & | plane )

Test whether a line and a plane are parallel.

Parameters

  line | the line
  plane | the plane

Returns
  bool, true or false

Definition at line 1226 of file analyticalGeometry.h.

## isParallel() [2/3]

template<typename T>

BALL_INLINE bool BALL::isParallel | ( | const TPlane3< T > & | a,
|  | const TPlane3< T > & | b )

Test whether two planes are parallel.

Parameters

  a | the first plane
  b | the second plane

Returns
  bool, true or false

Definition at line 1250 of file analyticalGeometry.h.

## isParallel() [3/3]

template<typename T>

BALL_INLINE bool BALL::isParallel | ( | const TPlane3< T > & | plane,
|  | const TLine3< T > & | line )

Test whether a plane and a line are parallel.

Parameters

  plane | the plane
  line | the line

Returns
  bool, true or false

Definition at line 1238 of file analyticalGeometry.h.

## molecules()

BALL_EXPORT MoleculeList BALL::molecules | ( | const AtomContainer & | fragment,
|  | bool | selected_only = false )

Extract all molecules from a kernel data structure.

## nucleicAcids()

BALL_EXPORT NucleicAcidList BALL::nucleicAcids | ( | const AtomContainer & | fragment,
|  | bool | selected_only = false )

Extract all nucleic acids from a kernel data structure.

## nucleotides()

BALL_EXPORT NucleotideList BALL::nucleotides | ( | const AtomContainer & | fragment,
|  | bool | selected_only = false )

Extract all nucleotides from a kernel data structure.

## operator!=()

BALL_EXPORT bool BALL::operator!= | ( | const String & | s1,
|  | const String & | s2 )

Inequality operator.

## operator*() [1/4]

template<typename T>

BALL_INLINE TVector3< T > BALL::operator* | ( | const T & | a,
|  | const TVector3< T > & | b )

Multiply a vector with a scalar. The symmetric case is a member of the vector class.

Definition at line 1121 of file vector3.h.

## operator*() [2/4]

template<typename T>

BALL_INLINE TVector4< T > BALL::operator* | ( | const T & | scalar,
|  | const TVector4< T > & | v )

Multiplication operator for a scalar and a vector

Returns
  TVector4 the new vector

Definition at line 841 of file vector4.h.

## operator*() [3/4]

template<typename T>

BALL_INLINE TAngle< T > BALL::operator* | ( | const T & | val,
|  | const TAngle< T > & | angle )

Multiplication operator. Multiplies a number with an angle.

Definition at line 704 of file angle.h.

## operator*() [4/4]

template<typename T>

BALL_INLINE TVector4< T > BALL::operator* | ( | const TVector4< T > & | v,
|  | const T & | scalar )

Multiplication operator for a vector and a scalar

Returns
  TVector4 the new vector

Definition at line 851 of file vector4.h.

## operator+() [1/21]

BALL_EXPORT String BALL::operator+ | ( | char | c,
|  | const String & | s )

Concatenates a character and a string.

## operator+() [2/21]

BALL_EXPORT String BALL::operator+ | ( | char | c,
|  | String && | s )

Concatenates a character and a string.

## operator+() [3/21]

BALL_EXPORT String BALL::operator+ | ( | const char * | char_ptr,
|  | const String & | s )

Concatenates a C type string and a string.

## operator+() [4/21]

BALL_EXPORT String BALL::operator+ | ( | const char * | char_ptr,
|  | String && | s )

Concatenates a C type string and a string.

## operator+() [5/21]

BALL_EXPORT String BALL::operator+ | ( | const String & | s,
|  | char | c )

Concatenates a string and a character.

## operator+() [6/21]

BALL_EXPORT String BALL::operator+ | ( | const String & | s1,
|  | const char * | char_ptr )

Concatenates a string and a C type string.

## operator+() [7/21]

BALL_EXPORT String BALL::operator+ | ( | const String & | s1,
|  | const String & | s2 )

Concatenates two strings.

## operator+() [8/21]

BALL_EXPORT String BALL::operator+ | ( | const String & | s1,
|  | const string & | s2 )

Concatenates two strings.

## operator+() [9/21]

BALL_EXPORT String BALL::operator+ | ( | const string & | s1,
|  | const String & | s2 )

Concatenates two strings.

## operator+() [10/21]

BALL_EXPORT String BALL::operator+ | ( | const String & | s1,
|  | String && | s2 )

Concatenates two strings.

## operator+() [11/21]

BALL_EXPORT String BALL::operator+ | ( | const String & | s1,
|  | string && | s2 )

Concatenates two strings.

## operator+() [12/21]

BALL_EXPORT String BALL::operator+ | ( | const string & | s1,
|  | String && | s2 )

Concatenates two strings.

## operator+() [13/21]

template<typename T>

BALL_INLINE TAngle< T > BALL::operator+ | ( | const T & | val,
|  | const TAngle< T > & | angle )

Plus operator. Adds a number with an angle (in rad!)

Definition at line 714 of file angle.h.

## operator+() [14/21]

template<typename T>

BALL_INLINE TVector4< T > BALL::operator+ | ( | const TVector4< T > & | a,
|  | const TVector4< T > & | b )

Addition operator for two vectors

Definition at line 821 of file vector4.h.

## operator+() [15/21]

template<typename Container, typename DataType, typename Position, typename Traits>

ConstRandomAccessIterator< Container, DataType, Position, Traits > BALL::operator+ | ( | Distance | distance,
|  | const ConstRandomAccessIterator< Container, DataType, Position, Traits > & | iterator )

Return an incremented iterator. It points to the element with the given distance from the element of the given iterator.

Exceptions

  Exception::InvalidIterator |

Definition at line 191 of file randomAccessIterator.h.

## operator+() [16/21]

BALL_EXPORT String BALL::operator+ | ( | String && | s,
|  | char | c )

Concatenates a string and a character.

## operator+() [17/21]

BALL_EXPORT String BALL::operator+ | ( | String && | s1,
|  | const char * | char_ptr )

Concatenates a string and a C type string.

## operator+() [18/21]

BALL_EXPORT String BALL::operator+ | ( | String && | s1,
|  | const String & | s2 )

Concatenates two strings.

## operator+() [19/21]

BALL_EXPORT String BALL::operator+ | ( | String && | s1,
|  | const string & | s2 )

Concatenates two strings.

## operator+() [20/21]

BALL_EXPORT String BALL::operator+ | ( | string && | s1,
|  | const String & | s2 )

Concatenates two strings.

## operator+() [21/21]

BALL_EXPORT String BALL::operator+ | ( | String && | s1,
|  | String && | s2 )

Concatenates two strings.

## operator-() [1/3]

template<typename DataT, typename PeakT, typename PositionT>

double BALL::operator- | ( | const Spectrum< DataT, PeakT, PositionT > & | s1,
|  | const Spectrum< DataT, PeakT, PositionT > & | s2 )

Difference operator. Calculate the sum of the unsigned differences of the two spectra

Definition at line 213 of file spectrum.h.

## operator-() [2/3]

template<typename T>

BALL_INLINE TAngle< T > BALL::operator- | ( | const T & | val,
|  | const TAngle< T > & | angle )

Minus operator. Subtracts the value of an angle (in rad!) from a number.

Definition at line 724 of file angle.h.

## operator-() [3/3]

template<typename T>

BALL_INLINE TVector4< T > BALL::operator- | ( | const TVector4< T > & | a,
|  | const TVector4< T > & | b )

Subtraction operator for two vectors

Returns
  TVector4 the new vector

Definition at line 831 of file vector4.h.

## operator<()

BALL_EXPORT bool BALL::operator< | ( | const String & | s1,
|  | const String & | s2 )

Less than comparison

## operator<<() [1/22]

::std::ostream & BALL::operator<< | ( | ::std::ostream & | os,
|  | const SnapShot & | ss )

Output stream operator for SnapShots.

## operator<<() [2/22]

template<typename ComplexTraits>

const RegularData1D & BALL::operator<< | ( | RegularData1D & | to,
|  | const TFFT1D< ComplexTraits > & | from )

Definition at line 674 of file FFT1D.h.

## operator<<() [3/22]

template<typename ComplexTraits>

const RegularData2D & BALL::operator<< | ( | RegularData2D & | to,
|  | const TFFT2D< ComplexTraits > & | from )

Global assignment operator from FFT3D to TRegularData3D<float>. This operator assigns the real part of the complex TFFT2D-data to the TRegularData2D<float> to.

Definition at line 865 of file FFT2D.h.

## operator<<() [4/22]

template<typename ComplexTraits>

const RegularData3D & BALL::operator<< | ( | RegularData3D & | to,
|  | const TFFT3D< ComplexTraits > & | from )

Global assignment operator from TFFT3D to TRegularData3D<float>. This operator assigns the real part of the complex TFFT3D-data to the TRegularData3D<float> to.

Definition at line 1038 of file FFT3D.h.

## operator<<() [5/22]

std::ostream & BALL::operator<< | ( | std::ostream & | os,
|  | const BALL::ShiftModel2D & | shiftmodel )

## operator<<() [6/22]

template<typename T>

std::ostream & BALL::operator<< | ( | std::ostream & | os,
|  | const BinaryFileAdaptor< T > & | data )

Output stream for BinaryFileAdaptors.

Definition at line 147 of file binaryFileAdaptor.h.

## operator<<() [7/22]

template<typename PositionType>

std::ostream & BALL::operator<< | ( | std::ostream & | os,
|  | const Peak< PositionType > & | peak )

Output operator

Definition at line 249 of file peak.h.

## operator<<() [8/22]

BALL_EXPORT std::ostream & BALL::operator<< | ( | std::ostream & | os,
|  | const PreciseTime & | time )

Global stream operators for PreciseTime and TimeStamp Print the contents of a PreciseTime object to a stream.

## operator<<() [9/22]

template<typename DataT, typename PeakT, typename PositionT>

std::ostream & BALL::operator<< | ( | std::ostream & | os,
|  | const Spectrum< DataT, PeakT, PositionT > & | spectrum )

## operator<<() [10/22]

BALL_EXPORT std::ostream & BALL::operator<< | ( | std::ostream & | os,
|  | const TimeStamp & | stamp )

Print the contents of a TimeStamp object to a stream.

## operator<<() [11/22]

template<typename ValueType>

std::ostream & BALL::operator<< | ( | std::ostream & | os,
|  | const TRegularData1D< ValueType > & | data )

Output operator.

Definition at line 788 of file regularData1D.h.

## operator<<() [12/22]

template<typename ValueType>

std::ostream & BALL::operator<< | ( | std::ostream & | os,
|  | const TRegularData2D< ValueType > & | data )

Output operator.

Definition at line 960 of file regularData2D.h.

## operator<<() [13/22]

template<typename ValueType>

std::ostream & BALL::operator<< | ( | std::ostream & | os,
|  | const TRegularData3D< ValueType > & | grid )

Output operator.

Definition at line 1405 of file regularData3D.h.

## operator<<() [14/22]

template<typename Node, typename Edge>

std::ostream & BALL::operator<< | ( | std::ostream & | os,
|  | const TSimpleMolecularGraph< Node, Edge > & | G )

Definition at line 290 of file simpleMolecularGraph.h.

## operator<<() [15/22]

std::ostream & BALL::operator<< | ( | std::ostream & | out,
|  | const DockResult & | dock_res )
throw | ( | ) |  |  |

Operator to write dock result into an ostream. Calls writeDockResult(std::ostream& file).

## operator<<() [16/22]

BALL_EXPORT std::ostream & BALL::operator<< | ( | std::ostream & | s,
|  | const Element & | element )

Element output operator. Prints the contents of an instance of Element to an ostream.

## operator<<() [17/22]

template<typename T>

std::ostream & BALL::operator<< | ( | std::ostream & | s,
|  | const TAngle< T > & | angle )

Output Operator. Writes the value of the angle to an output stream. The stream operator operator << has to be defined for the template parameter T.

Definition at line 746 of file angle.h.

## operator<<() [18/22]

template<typename T>

std::ostream & BALL::operator<< | ( | std::ostream & | s,
|  | const TQuaternion< T > & | q )

Definition at line 596 of file quaternion.h.

## operator<<() [19/22]

template<typename T>

std::ostream & BALL::operator<< | ( | std::ostream & | s,
|  | const TVector3< T > & | vector )

Output operator. Writes the values of three vector components of type T to an ostream. The components are writen in the order of x, y, z.

Definition at line 1136 of file vector3.h.

## operator<<() [20/22]

template<typename T>

std::ostream & BALL::operator<< | ( | std::ostream & | s,
|  | const TVector4< T > & | v )

Output Operator. Write the four components of the vector to an output stream. The values are enclosed by brackets.

  Example:

  (0.1 2.0 0 1)

Definition at line 875 of file vector4.h.

## operator<<() [21/22]

template<typename ComplexTraits>

const TRegularData2D< typename TFFT2D< ComplexTraits >::Complex > & BALL::operator<< | ( | TRegularData2D< typename TFFT2D< ComplexTraits >::Complex > & | to,
|  | const TFFT2D< ComplexTraits > & | from )

Global assignment operator from TFFT2D to TRegularData2D<Complex>

Definition at line 768 of file FFT2D.h.

## operator<<() [22/22]

template<typename ComplexTraits>

const TRegularData3D< typename TFFT3D< ComplexTraits >::Complex > & BALL::operator<< | ( | TRegularData3D< typename TFFT3D< ComplexTraits >::Complex > & | to,
|  | const TFFT3D< ComplexTraits > & | from )

Global assignment operator from TFFT3D to TRegularData3D<Complex>

Definition at line 927 of file FFT3D.h.

## operator<=()

BALL_EXPORT bool BALL::operator<= | ( | const String & | s1,
|  | const String & | s2 )

Less than or equal comparison

## operator==()

BALL_EXPORT bool BALL::operator== | ( | const String & | s1,
|  | const String & | s2 )

Equality operator.

## operator>()

BALL_EXPORT bool BALL::operator> | ( | const String & | s1,
|  | const String & | s2 )

Greater than comparison

## operator>=()

BALL_EXPORT bool BALL::operator>= | ( | const String & | s1,
|  | const String & | s2 )

Greater than or equal comparison

## operator>>() [1/11]

::std::istream & BALL::operator>> | ( | ::std::istream & | is,
|  | SnapShot & | ss )

Input stream operator for SnapShots.

## operator>>() [2/11]

std::istream & BALL::operator>> | ( | std::istream & | in,
|  | DockResult & | dock_res )
throw | ( | ) |  |  |

Operator to read dock result into an istream. Calls readDockResult(std::istream& file) .

## operator>>() [3/11]

template<typename T>

std::istream & BALL::operator>> | ( | std::istream & | is,
|  | BinaryFileAdaptor< T > & | data )

Input stream for BinaryFileAdaptors.

Definition at line 165 of file binaryFileAdaptor.h.

## operator>>() [4/11]

template<typename DataT, typename PeakT, typename PositionT>

std::istream & BALL::operator>> | ( | std::istream & | is,
|  | Spectrum< DataT, PeakT, PositionT > & | spectrum )

## operator>>() [5/11]

template<typename ValueType>

std::istream & BALL::operator>> | ( | std::istream & | is,
|  | TRegularData1D< ValueType > & | grid )

Input operator.

Definition at line 802 of file regularData1D.h.

## operator>>() [6/11]

template<typename ValueType>

std::istream & BALL::operator>> | ( | std::istream & | is,
|  | TRegularData2D< ValueType > & | grid )

Input operator.

Definition at line 978 of file regularData2D.h.

## operator>>() [7/11]

template<typename ValueType>

std::istream & BALL::operator>> | ( | std::istream & | is,
|  | TRegularData3D< ValueType > & | grid )

Input operator.

Definition at line 1425 of file regularData3D.h.

## operator>>() [8/11]

template<typename T>

std::istream & BALL::operator>> | ( | std::istream & | s,
|  | TAngle< T > & | angle )

Input Operator. Reads the value (in radians) of an angle from an instream using T::operator >>

Definition at line 733 of file angle.h.

## operator>>() [9/11]

template<typename T>

std::istream & BALL::operator>> | ( | std::istream & | s,
|  | TQuaternion< T > & | q )

Definition at line 588 of file quaternion.h.

## operator>>() [10/11]

template<typename T>

std::istream & BALL::operator>> | ( | std::istream & | s,
|  | TVector3< T > & | vector )

Input operator. Reads the values of three vector components of type T from an istream. The components are read in the order of x, y, z.

Definition at line 1127 of file vector3.h.

## operator>>() [11/11]

template<typename T>

std::istream & BALL::operator>> | ( | std::istream & | s,
|  | TVector4< T > & | v )

Input operator Reads four values of type T from an input stream and assigns them to the components x, y, z and h of the vector.

Definition at line 861 of file vector4.h.

## PDBAtoms()

BALL_EXPORT PDBAtomList BALL::PDBAtoms | ( | const AtomContainer & | fragment,
|  | const String & | expression = String() )

Extract PDB atoms matching an expression. This method extracts all PDB atoms of a kernel data structure into a list that match the Expression expression. If no expression is given, all PDB atoms will be returned.

Parameters

  fragment | the AtomContainer containing the atoms
  expression | the expression that selects the atoms (default: no expression)

## proteins()

BALL_EXPORT ProteinList BALL::proteins | ( | const AtomContainer & | fragment,
|  | bool | selected_only = false )

Extract all proteins from a kernel data structure.

## residues()

BALL_EXPORT ResidueList BALL::residues | ( | const AtomContainer & | fragment,
|  | bool | selected_only = false )

Extract all residues from a kernel data structure.

## secondaryStructures()

BALL_EXPORT SecondaryStructureList BALL::secondaryStructures | ( | const AtomContainer & | fragment,
|  | bool | selected_only = false )

Extract all secondary structures from a kernel data structure.

## setTorsionAngle()

BALL_EXPORT bool BALL::setTorsionAngle | ( | const Atom & | a1,
|  | const Atom & | a2,
|  | Atom & | a3,
|  | const Atom & | a4,
|  | Angle | angle )

Set the torsion angle defined by a1, a2, a3, a4. The atoms should be connected by bonds The position of a1 and a2 is kept fix, while the connected component containing a4 is rotated accordingly.

Returns
  false if the bond is not rotatable or if the molecule graph is not divided into two connected components upon removal of the bond (a2,a3)

## SolveQuadraticEquation()

template<typename T>

short BALL::SolveQuadraticEquation | ( | const T & | a,
|  | const T & | b,
|  | const T & | c,
|  | T & | x1,
|  | T & | x2 )

Solve a quadratic equation of the form a .

Parameters

  a |
  b |
  c |
  x1 | the first solution
  x2 | the second solution

Returns
  short the number of solutions (0 - 2)

Definition at line 310 of file analyticalGeometry.h.

## SolveSystem()

template<typename T>

bool BALL::SolveSystem | ( | const T * | m,
|  | T * | x,
|  | const Size | dim )

Solve a system of linear equations. Given a system of linear equations

  in matrix form, identify the solution .

  m should point to a C-style array containing the matrix A.

  The elements of A are row-ordered, i.e., they are ordered like this:

  x points to a C-style array that will contain the solution vector x upon successful termination of the function.

  If there is no solution or the system is under-determined, return false.

Parameters

  m | pointer to the factors in the equations
  x | pointer in which the results are stored
  dim | the dimension of the equation system (number of variables)

Returns
  bool true if a solution is found

Definition at line 191 of file analyticalGeometry.h.

## SolveSystem2()

template<typename T>

BALL_INLINE bool BALL::SolveSystem2 | ( | const T & | a1,
|  | const T & | b1,
|  | const T & | c1,
|  | const T & | a2,
|  | const T & | b2,
|  | const T & | c2,
|  | T & | x1,
|  | T & | x2 )

Solve a system of two equations of the form and .

Parameters

  a1,b1,c1,a2,b2,c2 | constants of the system
  x1 | the first solution
  x2 | the second solution

Returns
  bool true if a solution is found

Definition at line 285 of file analyticalGeometry.h.

## swapBytes() [1/9]

template<>

BALL_EXPORT void BALL::swapBytes | ( | double & |  | ) |

## swapBytes() [2/9]

template<>

BALL_EXPORT void BALL::swapBytes | ( | float & |  | ) |

## swapBytes() [3/9]

template<>

BALL_EXPORT void BALL::swapBytes | ( | int & |  | ) |

## swapBytes() [4/9]

template<>

BALL_EXPORT void BALL::swapBytes | ( | long & |  | ) |

## swapBytes() [5/9]

template<>

BALL_EXPORT void BALL::swapBytes | ( | short & |  | ) |

## swapBytes() [6/9]

template<typename T>

void BALL::swapBytes | ( | T & | t | ) |

Coping with endianness. This function swaps the bytes of a variable of type T if this type is of size 2n.

Definition at line 17 of file binaryFileAdaptor.h.

## swapBytes() [7/9]

template<>

BALL_EXPORT void BALL::swapBytes | ( | unsigned int & |  | ) |

## swapBytes() [8/9]

template<>

BALL_EXPORT void BALL::swapBytes | ( | unsigned long & |  | ) |

## swapBytes() [9/9]

template<>

BALL_EXPORT void BALL::swapBytes | ( | unsigned short & |  | ) |

## Variable Documentation

## CCONN__INSIDE

BALL_EXPORT const char BALL::CCONN__INSIDE

extern

## CCONN__INSIDE_PROBE

BALL_EXPORT const char BALL::CCONN__INSIDE_PROBE

extern

## CCONN__OUTSIDE

BALL_EXPORT const char BALL::CCONN__OUTSIDE

extern

## Distance_MAX

const Distance BALL::Distance_MAX = std::numeric_limits<Distance>::max()

static

Definition at line 233 of file COMMON/global.h.

## Distance_MIN

const Distance BALL::Distance_MIN = (std::numeric_limits<Distance>::min() + 1)

static

Definition at line 232 of file COMMON/global.h.

## Handle_MAX

const Handle BALL::Handle_MAX = std::numeric_limits<Handle>::max() - 1

static

Definition at line 237 of file COMMON/global.h.

## Handle_MIN

const Handle BALL::Handle_MIN = 0

static

Definition at line 236 of file COMMON/global.h.

## Index_MAX

const Index BALL::Index_MAX = std::numeric_limits<Index>::max()

static

Definition at line 241 of file COMMON/global.h.

## Index_MIN

const Index BALL::Index_MIN = 0

static

Definition at line 240 of file COMMON/global.h.

## INVALID_Distance

const Distance BALL::INVALID_Distance = std::numeric_limits<Distance>::max()

static

Definition at line 231 of file COMMON/global.h.

## INVALID_Handle

const Handle BALL::INVALID_Handle = std::numeric_limits<Handle>::max()

static

Definition at line 235 of file COMMON/global.h.

## INVALID_Index

const Index BALL::INVALID_Index = -1

static

Definition at line 239 of file COMMON/global.h.

## INVALID_Position

const Position BALL::INVALID_Position = std::numeric_limits<Position>::max()

static

Definition at line 243 of file COMMON/global.h.

## INVALID_Size

const Size BALL::INVALID_Size = std::numeric_limits<Size>::max()

static

Definition at line 247 of file COMMON/global.h.

## Log

BALL_EXPORT LogStream BALL::Log

extern

Global static instance of a logstream. This instance of LogStream is by default bound to cout cerr by calling the default constructor.

## MMFF94_number_atom_types

Size BALL::MMFF94_number_atom_types

extern

hold the maximum number of MMFF94 atom types + 1 (wildcard)

## Position_MAX

const Position BALL::Position_MAX = std::numeric_limits<Position>::max() - 1

static

Definition at line 245 of file COMMON/global.h.

## Position_MIN

const Position BALL::Position_MIN = 0

static

Definition at line 244 of file COMMON/global.h.

## Size_MAX

const Size BALL::Size_MAX = std::numeric_limits<Size>::max() - 1

static

Definition at line 249 of file COMMON/global.h.

## Size_MIN

const Size BALL::Size_MIN = 0

static

Definition at line 248 of file COMMON/global.h.

## TVector3< float >

template class BALL_EXPORT BALL::TVector3< float >

extern